#Author: J.M. Montañana 2020
#Updates: 
#	- refactoring of services by A. Cheptsov
# ES Indexes:   AM - Application Manager
#               RM - Resource Manager
#               EM - Execution Manager

#!/bin/bash

indexes="rm am am_depl em"

for i in ${indexes} ; do
	echo -e "\n#### 'ADDING THE ${i} INDEX"
	curl -XPUT "localhost:9200/${i}"
done;

# Empty structure for RM resources
# echo -e "\n#### 'ADDING THE RM RESOURCES INDEX"
# curl -XPOST "localhost:9200/rm/_doc/resources" -H "Content-Type: application/json" -d '{"previous_resources" : [] }'

# Empty structure for AM workflows
# echo -e "\n#### 'ADDING THE AM WORKFLOWS INDEX"
# curl -XPOST "localhost:9200/am/_doc/workflows" -H "Content-Type: application/json" -d '{"previous_workflows" : [] }'

# Empty structure for AM deployment plans
# echo -e "\n#### 'ADDING THE AM DEPLOYMENTS INDEX"
# curl -XPOST "localhost:9200/am_depl/_doc/deployments" -H "Content-Type: application/json" -d '{"previous_deployments" : [] }'

# Empty structure for EM executions
# echo -e "\n#### 'ADDING THE EM EXECUTIONS INDEX"
# curl -XPOST "localhost:9200/em/_doc/executions" -H "Content-Type: application/json" -d '{"previous_executions" : [] }'

echo -e "\n#### DEFINE MAPPING, needed for the queries ### ";
	curl -XPUT 'localhost:9200/rm/_mapping' -H "Content-Type: application/json" -d '{
		"properties": {
			"id" : {
				"type" : "text",
				"fields" : {
				"keyword" : {
					"type" : "keyword",
					"ignore_above" : 256
				}
				}
			},
			"address" : {
				"type" : "text",
				"fields" : {
				"keyword" : {
					"type" : "keyword",
					"ignore_above" : 256
				}
				}
			},
			"cpus" : {
				"type" : "text",
				"fields" : {
				"keyword" : {
					"type" : "keyword",
					"ignore_above" : 256
				}
				}
			},
			"cores/cpu" : {
				"type" : "text",
				"fields" : {
				"keyword" : {
					"type" : "keyword",
					"ignore_above" : 256
				}
				}
			},
			"desc" : {
				"type" : "text",
				"fields" : {
				"keyword" : {
					"type" : "keyword",
					"ignore_above" : 256
				}
				}
			}
		}
	}';

echo -e "\n#### ";
echo -e "\n#### DATA LAYER SETUP COMPLETED";