localpath=`pwd`

echo "#### cleanup db"
bash ../Data_Layer/cleanup.sh
echo "#### setup db"
bash ../Data_Layer/setup.sh
echo "#### setup nodejs"
bash ../Execution_Manager/Engine/nodejs/setup-nodejs-64.sh

echo "#### add_resource"
cd ../Resource_Manager/Frontend
bash add_resource.sh host_1 Resource_Examples/local_host_1.json
bash add_resource.sh host_2 Resource_Examples/local_host_2.json

echo "#### Application_Manager"
cd $localpath/../Application_Manager/Frontend

bash add_deployment.sh dep_1 Deployment_Examples/simple_deployment.json
bash add_workflow.sh work_1 Workflow_Examples/simple_workflow.json

bash add_deployment.sh dep_2 Deployment_Examples/simple_deployment_2.json
bash add_workflow.sh work_2 Workflow_Examples/simple_workflow_2.json

bash add_deployment.sh dep_3 Deployment_Examples/simple_deployment_3.json
bash add_workflow.sh work_3 Workflow_Examples/simple_workflow_3.json

echo "#### Execution_Manager"
cd $localpath/../Execution_Manager/Frontend/
bash add_execution.sh work_1 dep_1
bash add_execution.sh work_2 dep_2
rm id_generator/id_generator

echo "#### Run demo"
cd $localpath/../Execution_Manager/Engine/
bash run_demo.sh

sleep 1

echo "#### Status of executions"
cd $localpath
../Execution_Manager/Backend/get_all_executions.sh

echo "#### Start of Execution Manager GUI"
../Execution_Manager/Engine/nodejs/start-appmanager.sh