// Author:7 J.M. Montanana 2020
// Email: jmmontanana@gmail.com

package demo_wms;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Iterator;

import org.json.JSONArray;
import org.json.JSONObject;
import org.json.JSONException;
import java.util.ArrayList;

import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpRequestBase;
import java.io.OutputStreamWriter;
import java.io.BufferedWriter;

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;

public class app_submit {

	private static final String SSH_LOGIN = "userid";
	private static final String SSH_PASSWORD = "*****";

	private static Session setupSshSession(final String host_address) throws JSchException {
		Session session = new JSch().getSession(SSH_LOGIN, host_address, 22);
		session.setPassword(SSH_PASSWORD);
		session.setConfig("PreferredAuthentications", "publickey,keyboard-interactive,password");
		session.setConfig("StrictHostKeyChecking", "no"); // disable check for RSA key
		return session;
	}

	private static void closeConnection(Channel channel, Session session) {
		try {
			channel.disconnect();
		} catch (Exception ignored) {
		}
		session.disconnect();
	}

	public static void executeCommand(final String host_address, final String command) { // Cliente SSH final
		JSch jsch = new JSch();
		try {
			Session session = setupSshSession(host_address);
			session.connect();
			Channel channel = session.openChannel("exec");
			((ChannelExec) channel).setCommand(command);
			// next is only for printing output
			channel.setInputStream(null);
			((ChannelExec) channel).setErrStream(System.err);
			InputStream in = channel.getInputStream();
			channel.connect();
			byte[] tmp = new byte[1024];
			System.out.println("---Start of execution of the component");
			while (true) {
				while (in.available() > 0) {
					int i = in.read(tmp, 0, 1024);
					if (i < 0) {
						break;
					}
					System.out.print(new String(tmp, 0, i));
				}
				if (channel.isClosed()) {
					if (in.available() > 0) {
						continue;
					}
					break;
				}
				try {
					Thread.sleep(10);
				} catch (Exception ee) {
				}
			}
			closeConnection(channel, session);
		} catch (IOException | JSchException ex) {
		}
		System.out.println("---End of execution of the component");
	}

static class Hosts {
	ArrayList<String> array_id = new ArrayList<String>();
	ArrayList<String> array_addresses = new ArrayList<String>();
	private Integer total_ids ;
	private Integer total_ads ;

	public Hosts( ) {
		this.total_ids=0;
		this.total_ads=0;
	}

	public void add_id(String runid) {
		this.array_id.add(runid);
		this.total_ids = this.total_ids+1;
	}

	public void add_address(String runaddress) {
		this.array_addresses.add(runaddress);
		this.total_ads = this.total_ads+1;
	}

	public Integer size_id(){
		return this.array_id.size();
	}

	public String get_id(Integer i){
		return this.array_id.get(i);
	}

	public Integer size_addresses(){
		return this.array_addresses.size();
	}

	public String get_address(Integer i){
		if(i<this.total_ids){
		return this.array_addresses.get(i);
		}else{
		return "IndexOutOfBounds";
		}
	}
}


static class Applications {
	ArrayList<String> array_appname = new ArrayList<String>();
	ArrayList<String> array_idapp = new ArrayList<String>();
	ArrayList<String> array_descr = new ArrayList<String>();
	ArrayList<String> array_type = new ArrayList<String>();
	ArrayList<String> array_nrmpi = new ArrayList<String>();
	ArrayList<String> array_exec = new ArrayList<String>();
	ArrayList<String> array_depend = new ArrayList<String>();

	private Integer total_apps;
	private Integer total_descrs;
	private Integer total_types;
	private Integer total_nrmpi;
	private Integer total_execs;
	private Integer total_depends;

	public Applications( ) {
		this.total_apps=0;
		this.total_descrs=0;
		this.total_types=0;
		this.total_nrmpi=0;
		this.total_execs=0;
		this.total_depends=0;
	}
	public void add_appname(String name) {
		this.array_appname.add(name);
	}
	public void add_idapp(String runidc) {
		this.array_idapp.add(runidc);
		this.total_apps = this.total_apps+1;
	}

	public void add_descr(String dir) {
		this.array_descr.add(dir);
		this.total_descrs = this.total_descrs+1;
	}

	public void add_type(String host) {
		this.array_type.add(host);
		this.total_types = this.total_types+1;
	}


	public void add_nrmpi(String runidc) {
		this.array_nrmpi.add(runidc);
		this.total_nrmpi = this.total_nrmpi +1;
	}

	public void add_exec(String dir) {
		this.array_exec.add(dir);
		this.total_execs = this.total_execs+1;
	}

	public void add_depend(String host) {
		this.array_depend.add(host);
		this.total_depends = this.total_depends+1;
	}

	public Integer size_idapps(){
		return this.array_idapp.size();
	}

	public String get_idapp(Integer i){
		return this.array_idapp.get(i);
	}

	public String get_appname(Integer i) {
		if(i<this.total_apps){
		return this.array_appname.get(i);
		}else{
		return "IndexOutOfBounds";
		}
	}

	public String get_descr(Integer i){
		return this.array_descr.get(i);
	}

	public String get_type(Integer i){
		return this.array_type.get(i);
	}

	public String get_nrmpi(Integer i){
		return this.array_nrmpi.get(i);
	}

	public String get_exec(Integer i){
		return this.array_exec.get(i);
	}

	public String get_depend(Integer i){
		return this.array_depend.get(i);
	}

}


static class Deployments {
	ArrayList<String> array_names = new ArrayList<String>();
	ArrayList<String> array_idcs = new ArrayList<String>();
	ArrayList<String> array_dirs = new ArrayList<String>();
	ArrayList<String> array_hosts = new ArrayList<String>();
	private Integer total_idcs;
	private Integer total_dirs;
	private Integer total_hosts;

	public Deployments( ) {
		this.total_idcs=0;
		this.total_dirs=0;
		this.total_hosts=0;
	}

	public void add_name(String name) {
		this.array_names.add(name);
	}

	public void add_idcomponent(String runidc) {
		this.array_idcs.add(runidc);
		this.total_idcs = this.total_idcs+1;
	}

	public void add_dir(String dir) {
		this.array_dirs.add(dir);
		this.total_dirs = this.total_dirs+1;
	}

	public void add_host(String host) {
		this.array_hosts.add(host);
		this.total_hosts = this.total_hosts+1;
	}

	public Integer size_idcs(){
		return this.array_idcs.size();
	}

	public String get_name(Integer i){
		return this.array_names.get(i);
	}

	public String get_idcomponent(Integer i){
		return this.array_idcs.get(i);
	}

	public Integer size_dirs(){
		return this.array_dirs.size();
	}

	public String get_dir(Integer i){
		return this.array_dirs.get(i);
	}
	public Integer size_hosts(){
		return this.array_hosts.size();
	}

	public String get_host(Integer i){
		return this.array_hosts.get(i);
	}
}



static class Executions {
	ArrayList<String> array_idexecs = new ArrayList<String>();
	ArrayList<String> array_appid =   new ArrayList<String>();
	ArrayList<String> array_deplid =  new ArrayList<String>();
	ArrayList<String> array_status =  new ArrayList<String>();
	private Integer total_execs;
	private Integer total_app;
	private Integer total_depl;

	public Executions( ) {
		this.total_execs=0;
		this.total_app=0;
		this.total_depl=0;
	}

	public void add_idexec(String exec_id) {
		this.array_idexecs.add(exec_id);
		this.total_execs = this.total_execs+1;
	}

	public void add_app(String dir) {
		this.array_appid.add(dir);
		this.total_app = this.total_app+1;
	}

	public void add_depl(String host) {
		this.array_deplid.add(host);
		this.total_depl = this.total_depl+1;
	}

	public void add_status(String status) {
		this.array_status.add(status);
	}

	public Integer size_idexec(){
		return this.array_idexecs.size();
	}

	public String get_idexec(Integer i){
		return this.array_idexecs.get(i);
	}

	public String get_app(Integer i){
		return this.array_appid.get(i);
	}

	public String get_depl(Integer i){
		return this.array_deplid.get(i);
	}

    public void set_status(Integer i, String status) {
//        this.array_status.set(i,status);

        try { 
            post_es_data_server("/em/_update/" + this.array_idexecs.get(i),
		        "{ \"doc\": { \"status\": \"" + status + "\" }  }");
        }
        catch (IOException e)
        {}
    }

}



static class CombinedData {
	ArrayList<Integer> array_deploy = new ArrayList<Integer>();
	ArrayList<Integer> array_hosts = new ArrayList<Integer>();
	ArrayList<Integer> array_depend = new ArrayList<Integer>();
	ArrayList<Integer> array_completed = new ArrayList<Integer>();
	ArrayList<Integer> array_exec_id = new ArrayList<Integer>();

	private Integer total_components;

	public CombinedData( ) {
		this.total_components=0;
	}

	public void add_comp(Integer i) {
		this.array_depend.add(this.total_components);//depend on itself stands for not dependence
		this.array_completed.add(0);//0 stands for false or not-completed
		this.total_components = this.total_components+1;
	}

	public void set_completed(Integer i, Integer value) {
		this.array_completed.set(i,value);
	}

	public void set_dependence(Integer i, Integer j) {
		this.array_depend.set(i,j);
	}

	public void add_deploy(Integer j) {
		this.array_deploy.add(j);
	}

	public void add_host(Integer k) {
		this.array_hosts.add(k);
	}

	public Integer size_CombinedData(){
		return this.total_components;
	}

	public Integer get_deploy(Integer i) {
		return this.array_deploy.get(i);
	}

	public Integer get_host(Integer i) {
		return this.array_hosts.get(i);
	}

	public Integer get_depend(Integer i) {
		return this.array_depend.get(i);
	}

	public Integer get_completed(Integer i) {
		return this.array_completed.get(i);
	}

	public void add_array_exec_id(Integer i ) {
		this.array_exec_id.add(i);
	}

	public Integer get_array_exec_id(Integer i) {
		return this.array_exec_id.get(i);
	}
}

	public static String httpRequest(String type, String url, String body) {
		URL Url;
		HttpURLConnection conn;
		BufferedReader rd;
		String line;
		StringBuilder result = new StringBuilder();
		try {
			Url = new URL(url);
			conn = (HttpURLConnection) Url.openConnection();
			conn.setDoOutput(true);
			conn.setRequestMethod(type);
			conn.setRequestProperty("Content-Type", "application/json");
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(conn.getOutputStream()));
			writer.write(body);
			writer.flush();
			rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
			while ((line = rd.readLine()) != null) {
				result.append(line);
			}
			rd.close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result.toString();
	}

	public static String httpGet(String url, String body) {
		return httpRequest("GET", url, body);
	}

    public static String httpPost(String url, String body) {
    	return httpRequest("POST", url, body);
	}

	public static String request_es_data_server(String table, String query ) throws IOException {
		String urlString = new String();
		String responsestring = new String();
		String mfserveraddress="localhost";//arfc.readConfigFile("mfserveraddress",tmppath+"configphptv03.properties");
		String mfserverport="9200";//arfc.readConfigFile("mfserverport",tmppath+"configphptv03.properties");
		urlString = "http://"+mfserveraddress+":"+mfserverport+table;
		System.out.println(ConsoleColors.GREEN_BRIGHT+"\n Request to ES using the url: "+urlString+ConsoleColors.RESET);
		responsestring = httpGet(urlString, query);
		return responsestring;
	}

	public static String post_es_data_server(String table, String query ) throws IOException {
		String urlString = new String();
		String responsestring = new String();
		String mfserveraddress="localhost";//arfc.readConfigFile("mfserveraddress",tmppath+"configphptv03.properties");
		String mfserverport="9200";//arfc.readConfigFile("mfserverport",tmppath+"configphptv03.properties");
		urlString = "http://"+mfserveraddress+":"+mfserverport+table;
		System.out.println(ConsoleColors.GREEN_BRIGHT+"\n Request to ES using the url: "+urlString+ConsoleColors.RESET);
		responsestring = httpPost(urlString, query);
		return responsestring;
	}

	public static void findhosts(Hosts hosts ) throws IOException {
// 		String responsejsonString = request_es_data_server("/rm/_search?",
// 		"{ \"query\": { \"match_all\": { } }, \"collapse\" : { \"field\" : \"id.keyword\" }, \"sort\": [ { \"timestamp\": { \"order\": \"desc\" } } ] }");
		String responsejsonString = request_es_data_server("/rm/_search?size=200",
		"{ \"query\": { \"match_all\": { } }  }");

		try{
			JSONObject jsonObject =new JSONObject(responsejsonString);
			JSONObject hitsJson = jsonObject.getJSONObject("hits");
			JSONArray arr = hitsJson.getJSONArray("hits");

            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================");
			System.out.println(" QUERYING THE RESOURCE MANAGER: FOUND " 
                + (arr.length()/*-1*/) + " HOSTS");
            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================\n"
                +ConsoleColors.RESET);


			for (int i = 0; i < arr.length(); i++) {
				JSONObject hitJsonB = arr.getJSONObject(i);
				JSONObject hitsJsonC = hitJsonB.getJSONObject("_source");

                if (hitsJsonC.has("id") &&  hitsJsonC.has("address")) {
				    System.out.println("========================================");
				    System.out.println(ConsoleColors.GREEN_BRIGHT +" HOST " +ConsoleColors.YELLOW_BRIGHT +i +" full json:"+ConsoleColors.RESET);
				    System.out.println(" "+hitsJsonC);
				    String runid =(String)hitsJsonC.get("id");
				    String runaddress =(String)hitsJsonC.get("address");
				    hosts.add_id(runid);
				    hosts.add_address(runaddress);
				    System.out.println("========================================");
                }
			}
		} catch (JSONException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}

	public static void findapplications(Applications applications ) throws IOException {
		String responsejsonString = request_es_data_server("/am/_search",
		"{ \"query\": { \"match_all\": { } } }");
		try{
			JSONObject jsonObject =new JSONObject(responsejsonString);
			JSONObject hitsJson = jsonObject.getJSONObject("hits");
			JSONArray arr = hitsJson.getJSONArray("hits");

            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================");
			System.out.println(" QUERYING THE APPLICATION MANAGER: FOUND " 
                + (arr.length()/*-1*/) + " APPLICATIONS");
            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================\n"
                +ConsoleColors.RESET);

			for (int i = 0; i < arr.length() /*-1 reduce of general info*/; i++) {
				JSONObject hitJsonB = arr.getJSONObject(i);

				System.out.println("========================================");
				System.out.println(ConsoleColors.GREEN_BRIGHT +" APPLICATION " 
                    +ConsoleColors.YELLOW_BRIGHT + "[" + i + "]" +ConsoleColors.WHITE+" full json:"+ConsoleColors.RESET);
				System.out.println(" "+hitJsonB);
                System.out.println("========================================");

				String app_name =(String)hitJsonB.get("_id");
				JSONObject hitsJsonC = hitJsonB.getJSONObject("_source");
				JSONArray jarr = hitsJsonC.getJSONArray("components");

              	for (int j = 0; j < jarr.length(); j++) {
					JSONObject jhitJsonB = jarr.getJSONObject(j);

                    if (hitsJsonC.has("id") &&  hitsJsonC.has("descr")) {
					    System.out.println("========================================");
					    System.out.println(ConsoleColors.GREEN_BRIGHT +" --> COMPONENT " +ConsoleColors.YELLOW_BRIGHT +j 
                            +ConsoleColors.WHITE+" full json:"+ConsoleColors.RESET);
					    System.out.println(" "+jhitJsonB);

					    String runidcapp =(String)jhitJsonB.get("id");
					    String rundescr =(String)jhitJsonB.get("descr");
					    String runtype =(String)jhitJsonB.get("type");
					    String runnrmpi ="";
					    if ( runtype.equals("mpi")){
						    runnrmpi =(String)jhitJsonB.get("nr_mpi");
					    }
					    String runexec =(String)jhitJsonB.get("exec");
					    String rundepend =(String)jhitJsonB.get("depend");

					    applications.add_appname(app_name);
					    applications.add_idapp(runidcapp);
					    applications.add_descr(rundescr);
					    applications.add_type(runtype);

					    applications.add_nrmpi(runnrmpi);
					    applications.add_exec(runexec);
					    applications.add_depend(rundepend);
					    System.out.println("========================================");
                    }
				}
			}
		} catch (JSONException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}

	public static void finddeployments(Deployments deployments  ) throws IOException {
		String responsejsonString = request_es_data_server("/am_depl/_search",
		"{ \"query\": { \"match_all\": { } } }");
		try{
			JSONObject jsonObject =new JSONObject(responsejsonString);
			JSONObject hitsJson = jsonObject.getJSONObject("hits");
			JSONArray arr = hitsJson.getJSONArray("hits");

            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================");
			System.out.println(" QUERYING THE APPLICATION MANAGER: FOUND " 
                + (arr.length()/* -1 */) + " DEPLOYMENT PLANS");
            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================\n"
                +ConsoleColors.RESET);

			for (int i = 0; i < arr.length()/*-1*/ /*reduce of general info*/; i++) {
				JSONObject hitJsonB = arr.getJSONObject(i);
				System.out.println(" "+hitJsonB);
				String deploy_name =(String)hitJsonB.get("_id");
				JSONObject hitsJsonC = hitJsonB.getJSONObject("_source");
				JSONArray jarr = hitsJsonC.getJSONArray("components");
				for (int j = 0; j < jarr.length(); j++) {
					JSONObject jhitJsonB = jarr.getJSONObject(j);
                    if (hitsJsonC.has("id") &&  hitsJsonC.has("descr")) {
    					System.out.println("========================================");
	    				System.out.println(ConsoleColors.GREEN_BRIGHT +" DEPLOYMENT " +ConsoleColors.YELLOW_BRIGHT +j +" full json:"+ConsoleColors.RESET);
					System.out.println(" "+jhitJsonB);

					    String runidc =(String)jhitJsonB.get("id");
					    String runahost =(String)jhitJsonB.get("host");
					    String rundir =(String)jhitJsonB.get("dir");
					    String runtype =(String)jhitJsonB.get("auth");
					    deployments.add_name(deploy_name);
					    deployments.add_idcomponent(runidc);
					    deployments.add_dir(rundir);
					    deployments.add_host(runahost);
					    System.out.println("========================================");
                    }
				}
			}
		} catch (JSONException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}



	public static void findexecutions(Executions executions) throws IOException {
		String responsejsonString = request_es_data_server("/em/_search",
		"{ \"query\": { \"match_all\": { } } }");
		try {
			JSONObject jsonObject =new JSONObject(responsejsonString);
			JSONObject hitsJson = jsonObject.getJSONObject("hits");
			JSONArray arr = hitsJson.getJSONArray("hits");

            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================");
			System.out.println(" QUERYING THE EXECUTION MANAGER: FOUND " 
                + (arr.length()/*-1*/) + " EXECUTIONS");
            System.out.println(ConsoleColors.GREEN_BRIGHT + 
                "======================================================\n"
                +ConsoleColors.RESET);

			for (int i = 0; i < arr.length()/*reduce of general info*/; i++) {
                System.out.println("ADDING NEW EXEC");
				JSONObject hitJsonB = arr.getJSONObject(i);
				String exec_id = (String)hitJsonB.get("_id");
				JSONObject hitsJsonC = hitJsonB.getJSONObject("_source");
				if (hitsJsonC.has("app_id") &&  hitsJsonC.has("depl_id")) {
				    System.out.println(ConsoleColors.GREEN_BRIGHT +" EXECUTION " 
                        +ConsoleColors.YELLOW_BRIGHT +i +" full json:"
                        +ConsoleColors.RESET);
				    System.out.println(" "+hitJsonB);
				    String exec_app =(String)hitsJsonC.get("app_id");
				    String exec_depl =(String)hitsJsonC.get("depl_id");
                    String exec_status =(String)hitsJsonC.get("status");
				    executions.add_idexec(exec_id);
				    executions.add_app(exec_app);
				    executions.add_depl(exec_depl);
				    executions.add_status(exec_status);
				    System.out.println("========================================");
				}
			}
		} catch (JSONException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
	}

	public static void main(String[] args) throws IOException {
		Hosts hosts = new Hosts();
		findhosts(hosts );
			System.out.println(ConsoleColors.YELLOW_BOLD_BRIGHT+
                "---------------- PARSED VALUES OF INFRASTRUCTURE---------------------"
                +ConsoleColors.RESET);
			for (int i = 0; i < hosts.size_id(); i++) {
				System.out.println(hosts.get_id(i)+ ":"+ hosts.get_address(i));
			}
			System.out.println();

		Applications applications = new Applications();
		findapplications( applications );
			System.out.println(ConsoleColors.YELLOW_BOLD_BRIGHT+
                "---------------- PARSED VALUES OF APPLICATIONS---------------------"
                +ConsoleColors.RESET);
			for (int i = 0; i < applications.size_idapps(); i++) {
				System.out.println( applications.get_appname(i)+ " : "+  applications.get_idapp(i)+ " : "+ applications.get_type(i)+ " : "+ applications.get_nrmpi(i)+ " : "+ applications.get_exec(i)+ " : "+ applications.get_depend(i));
			}
			System.out.println();

		Deployments deployments = new Deployments();
		finddeployments(deployments );
			System.out.println(ConsoleColors.YELLOW_BOLD_BRIGHT+"---------------- PARSED VALUES OF DEPLOYMENTS---------------------"+ConsoleColors.RESET);
			for (int i = 0; i < deployments.size_idcs(); i++) {
				System.out.println(deployments.get_name(i)+ " : "+deployments.get_idcomponent(i)+ " : "+ deployments.get_host(i)+ " : "+ deployments.get_dir(i));
			}

		Executions executions = new Executions();
		findexecutions(executions  );
			System.out.println(ConsoleColors.YELLOW_BOLD_BRIGHT+"---------------- PARSED VALUES OF DEPLOYMENTS---------------------"+ConsoleColors.RESET);
			for (int i = 0; i < executions.size_idexec(); i++) {
				System.out.println(executions.get_idexec(i)+ " : "+ executions.get_app(i)+ " : "+ executions.get_depl(i));
			}

		////////////////////////////////////////////////////////////////////////////////////////////////////////
		CombinedData combined_data= new CombinedData();
		CombinedData pendingexecution= new CombinedData();

		System.out.println("\n\n\n"+ConsoleColors.YELLOW_BOLD_BRIGHT+"----------------COMBINING DATA -------------"+ConsoleColors.RESET);
		for (int i = 0; i < applications.size_idapps(); i++) {
			Integer j=0;
			while(j< deployments.size_idcs() && (! applications.get_idapp(i).equals(deployments.get_idcomponent(j)))){
				j++;
			}
			Integer k=0;
			while(k< hosts.size_id() && (! deployments.get_host(j).equals(hosts.get_id(k)))){
				k++;
			}
			if(k>= hosts.size_id()){
				System.out.println("Error address of host \""+deployments.get_host(j)+"\" not found in the rm!");
				System.exit(0);
			}
			// i es id de la tabla aplicaciones, apunta a un componente
			// j es id de la tabla deployments que tiene ese componente
			// k es el id de la tabla hosts que corresponde con el host del componete en la tabla deployments
			combined_data.add_comp(i);
			combined_data.add_deploy(j);
			combined_data.add_host(k);
			//we add to the pendingexecution if the work and dep are both in the same execu on the list  executions.size_idexec()
			Integer found_exec =0;
			int e=0;
			while (  e < executions.size_idexec()   &&  found_exec==0) {
				if (executions.get_app(e).equals(applications.get_appname(i)) &&  executions.get_depl(e).equals(deployments.get_name(j)) ){
				found_exec=1;
				pendingexecution.add_comp(i);
				pendingexecution.add_deploy(j);
				pendingexecution.add_host(k);
				pendingexecution.add_array_exec_id(e);
				}
				e++;
			}
		}
		//defining index of dependences between components
		for (int i = 0; i < combined_data.size_CombinedData(); i++) {
			Integer j=0;
			while(j< applications.size_idapps() && (! applications.get_depend(i).equals(applications.get_idapp(j)))){
				j++;
			}
			if(j< applications.size_idapps()){
				combined_data.set_dependence(i,j);
			}
		}
		//defining index of dependences between components
		for (int i = 0; i < pendingexecution.size_CombinedData(); i++) {
			Integer j=0;
			while(j< applications.size_idapps() && (! applications.get_depend(i).equals(applications.get_idapp(j)))){
				j++;
			}
			if(j< applications.size_idapps()){
				pendingexecution.set_dependence(i,j);
			}
		}

		// print for debugging
		for (int i = 0; i < combined_data.size_CombinedData(); i++) {
			Integer j=combined_data.get_deploy(i);
			Integer k=combined_data.get_host(i);
			System.out.print("["+i+"] "+ applications.get_appname(i) + " : "+deployments.get_name(j)+" : "+applications.get_idapp(i)+ " : "+ applications.get_type(i)+ " : "+ applications.get_nrmpi(i)+ " : "+ applications.get_exec(i)+ " : ");

			if(combined_data.get_depend(i)!= i){
				System.out.print("["+combined_data.get_depend(i)+"] ");
			}else{
				System.out.print("[-] ");
			}
			System.out.print(applications.get_depend(i));
			if (j< deployments.size_idcs() ){
				System.out.print(" : "+ deployments.get_host(j)+ " : "+ deployments.get_dir(j));
			}
			if (k< hosts.size_id() ){
				System.out.println(" :"+ hosts.get_address(k));
			}
		}
		System.out.println("\n\n\n"+ConsoleColors.YELLOW_BOLD_BRIGHT+"----------------PENDING EXECUTION -------------"+ConsoleColors.RESET);
		Integer numexec = 0;
		// print for debugging
		for (int i = 0; i < pendingexecution.size_CombinedData(); i++) {
			Integer j=pendingexecution.get_deploy(i);
			Integer k=pendingexecution.get_host(i);
			numexec = pendingexecution.get_array_exec_id(i);
			System.out.print("["+i+"] ");
			System.out.print(executions.get_idexec(numexec)  + " : "+ applications.get_appname(i) + " : "+deployments.get_name(j)+" : "+applications.get_idapp(i)+ " : "+ applications.get_type(i)+ " : "+ applications.get_nrmpi(i)+ " : "+ applications.get_exec(i)+ " : ");

			if(pendingexecution.get_depend(i)!= i){
				System.out.print("["+pendingexecution.get_depend(i)+"] ");
			}else{
				System.out.print("[-] ");
			}
			System.out.print(applications.get_depend(i));
			if (j< deployments.size_idcs() ){
				System.out.print(" : "+ deployments.get_host(j)+ " : "+ deployments.get_dir(j));
			}
			if (k< hosts.size_id() ){
				System.out.println(" :"+ hosts.get_address(k));
			}
		}




		String execution_in_process= "";
		System.out.println("\n\n"+ConsoleColors.YELLOW_BOLD_BRIGHT+"----------- START OF EXECUTION OF THE APPLICATION/S -----------------"+ConsoleColors.RESET);
		String host_address = "";
		String app_folder = "";
		for (int m = 0; m < 4; m++) {
			System.out.println("");
			//RUNNING TASKS
			for (int i = 0; i < pendingexecution.size_CombinedData(); i++) {
				numexec = pendingexecution.get_array_exec_id(i);
				execution_in_process=executions.get_idexec(numexec);
				if(pendingexecution.get_depend(i)== i && pendingexecution.get_completed(i)==0 ){
					host_address = hosts.get_address( pendingexecution.get_host(i));
					app_folder= deployments.get_dir(pendingexecution.get_deploy(i));

					System.out.println(" Running command ssh "+ host_address +" '"+app_folder+"/"+applications.get_exec(i)+ " "+execution_in_process+"'");
					executeCommand(host_address,app_folder+"/"+applications.get_exec(i)+ " "+execution_in_process);
					pendingexecution.set_completed(i,1);
				}else if (pendingexecution.get_completed(i)==0 ){
					Integer parent=pendingexecution.get_depend(i);
					if (pendingexecution.get_completed(parent)==2){
						host_address = hosts.get_address( pendingexecution.get_host(i));
						app_folder= deployments.get_dir(pendingexecution.get_deploy(i));
						System.out.println(" Running command ssh "+ host_address +" '"+app_folder+"/"+applications.get_exec(i)+ " "+execution_in_process+"'");
						executeCommand(host_address,app_folder+"/"+applications.get_exec(i)+ " "+execution_in_process);
						pendingexecution.set_completed(i,1);
					}
				}
			}
			//PRINT STATUS
			for (int i = 0; i < pendingexecution.size_CombinedData(); i++) {
				if( pendingexecution.get_completed(i)==1 ){
					System.out.println(ConsoleColors.RED_BOLD+"["+i+"]"+"RUNNING"+ConsoleColors.RESET);
				}else if( pendingexecution.get_completed(i)==2 ){
					System.out.println(ConsoleColors.GREEN_BOLD+"["+i+"]"+"COMPLETED"+ConsoleColors.RESET);
				}else if (pendingexecution.get_completed(i)==0 ){
					Integer parent=pendingexecution.get_depend(i);
					if (pendingexecution.get_completed(parent)!=2){
						System.out.println("["+i+"]"+"WAITING... "+"["+parent+"]" );
					}
				}
			}
			//UPDATING STATUS OF COMPLETED COMPONENTS
			for (int i = 0; i < pendingexecution.size_CombinedData(); i++) {
				numexec = pendingexecution.get_array_exec_id(i);
				execution_in_process=executions.get_idexec(numexec);
				if (pendingexecution.get_completed(i)==0 ){
					Integer parent=pendingexecution.get_depend(i);
					if (pendingexecution.get_completed(parent)==2){
						host_address = hosts.get_address( pendingexecution.get_host(i));
						app_folder= deployments.get_dir(pendingexecution.get_deploy(i));
						System.out.println(" Running command ssh "+ host_address +" '"+app_folder+"/"+applications.get_exec(i)+ " "+execution_in_process+"'");
						executeCommand(host_address,app_folder+"/"+applications.get_exec(i)+ " "+execution_in_process);
						pendingexecution.set_completed(i,1);
					}
				}
			}
			for (int i = 0; i < pendingexecution.size_CombinedData(); i++) {
				if( pendingexecution.get_completed(i)==1 ){
					pendingexecution.set_completed(i,2);
				}
			}
			System.out.println("...\n\n");
		}

        for (int i=0; i<executions.size_idexec(); i++)
            executions.set_status(i, "completed");
	}
}
