#!/bin/bash

#  Copyright (C) 2016-2018 University of Stuttgart
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

PREV_DIR=`pwd`;

# GLOBAL VARIABLES
	BASE_DIR=`dirname $0`;
	cd ${BASE_DIR};
	BASE_DIR=`pwd`;
	
	SERVER_DIR=${BASE_DIR}/../../../tmp/server_data;
	TMP_DIR=${SERVER_DIR}/tmp;
	DIST_DIR=${SERVER_DIR}/dist;
	if [ ! -e ${SERVER_DIR} ]; then
		mkdir -p ${SERVER_DIR};
	fi;
	if [ ! -e ${TMP_DIR} ]; then
		mkdir -p ${TMP_DIR};
	fi;
	if [ ! -e ${DIST_DIR} ]; then
		mkdir -p ${DIST_DIR};
	fi;

# setup the environment
	cp package.json  ${SERVER_DIR};

	npm install;
	echo -e "Done.\n";

cd ${PREV_DIR}