#!/bin/bash

PREV_DIR=`pwd`;

#GLOBAL VARIABLES
	BASE_DIR=`dirname $0`;
	cd ${BASE_DIR};
	BASE_DIR=`pwd`;
	
	SERVER_DIR=${BASE_DIR}/../../../tmp/server_data;
	TMP_DIR=${SERVER_DIR}/tmp;
	DIST_DIR=${SERVER_DIR}/dist;
	appmanager_port=8700;
	cd server_code;
	
# IF THE SERVER WAS RUNNING, WE STOP IT BEFORE START A NEW INSTANCE
	bash ../stop-appmanager.sh
# START A NEW INSTACE OF THE APPMANAGER
	if [ ! -d node_modules ]; then
		ln -s ${SERVER_DIR}/node_modules node_modules;
	fi;
	
	touch ${TMP_DIR}/appmanager.pid
	
	node appmanager_app.js &
	pid=$!;
	echo "pid if the server is ${pid}";
	echo ${pid} > ${TMP_DIR}/appmanager.pid;
	sleep 1;

# CHECK IF THE APPLICATION MANAGER IS RUNNING
	let "j=0";
	HTTP_STATUS=$(curl -s -w %{http_code} http://localhost:${appmanager_port})
	while [[ ${HTTP_STATUS} != *"200"* ]] && [ ${j} -lt 30 ] ; do
			echo -n "$j. "; let "j += 1 ";  sleep 1;
			HTTP_STATUS=$(curl -s -w %{http_code} http://localhost:${appmanager_port})
	done;

	if [ ${j} -ge 30 ]; then
			echo "[ERROR]: APPLICATION MANAGER doesn't started.";
			exit;
	fi;
	echo ; #Here, we will show the current version of the running WMS APPLICATION MANAGER
	curl http://localhost:${appmanager_port};
	echo -e "\n\n";

cd ${PREV_DIR}