#!/bin/bash
#Author: A. Cheptsov

# checking the parameters
if [ $# -ne 2 ]; then 
    echo "Illegal nr. of parameters."
    echo "Usage: $0 application_id deployment_id"
    exit 2
fi

if [ ! -f  id_generator/id_generator ]; then
    g++ id_generator/id_generator.cpp -o id_generator/id_generator -std=c++11
fi

ID=`id_generator/id_generator`

json_body="{\"app_id\":\"$1\",\"depl_id\":\"$2\",\"status\":\"pending\"}"
curl -s -S -XPUT "localhost:9200/em/_doc/"${ID} -H "Content-Type: application/json" -d "$json_body" > /dev/null
echo -e '\n'

###json_body="{\"script\" : {\"source\": \"ctx._source.previous_executions.add(params.new_execution)\", \"lang\": \"painless\", \"params\" : { \"new_execution\" : \"$ID\" } } }"
###curl -s -S -XPOST "localhost:9200/em/_update/executions" -H "Content-Type: application/json" -d "$json_body"
###echo -e '\n'

echo -e "\n#### THE NEW EXECUTION HAS BEEN REGISTERED BY THE EXECUTION MANAGER WITH THE ID: $ID ###\n";
../Backend/get_all_executions.sh

echo -e '\n'