/*
 * Copyright (c) 2019 	   Alexey Cheptsov. HLRS.  All rights reserved.
 * $COPYRIGHT$
 *
 * Additional copyrights may follow
 *
 * $HEADER$
 */
#include <boost/date_time/posix_time/posix_time.hpp>
#include <chrono> // chrono::milliseconds(x)

#include "dirent.h"
#include <stdlib.h>
#include <stdio.h>
#include <curl/curl.h> 
#include <malloc.h>
#include <sys/stat.h>
#include <string.h>
#include <dirent.h>
#include <iostream>
#include <algorithm>
#include <fstream>

using namespace std;


int main (int argc, char* argv[]) {
    long year;
    long month;
    long day;
    long hours;
    long minutes;
    long seconds;
    long milliseconds;

    // Get the time offset in current day
    const boost::posix_time::time_duration td = boost::posix_time::microsec_clock::local_time().time_of_day();

    hours        = td.hours();
    minutes      = td.minutes();
    seconds      = td.seconds();
    milliseconds = td.total_milliseconds() - ((hours * 3600 + minutes * 60 + seconds) * 1000);

    time_t t = time(0);   // get time now
    tm* now = localtime(&t);

    year = now->tm_year + 1900;
    month = now->tm_mon + 1;
    day = now->tm_mday;

    printf("%04ld-%02ld-%02ldT%02ld:%02ld:%02ld.%03ld", year, month, day, hours, minutes, seconds, milliseconds);
}