//author: J.M.Montanana
//Copyright HRLS 2017
//functions as kbhit() have been downloaded from internet.
//based on the use of ps and /proc/stat , /proc/diskstats, /proc/uptime, /proc/meminfo, /proc/[pid]/io, nproc, /proc/cpuinfo

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <stdbool.h>
#include <sys/ioctl.h>//to get the screen resolution

#include <termios.h>
#include <unistd.h> //for sleep and usleep
#include <time.h> //for nano sleep
#include <fcntl.h>
#include <ctype.h>
#include <sys/select.h>
#include <curl/curl.h>
#include "stats_prints.h"
#include <sys/time.h>
//#include <conio.h> //gtech and kbhit
	//apt-get install libncurses5-dev libncursesw5-dev
	//yum ncurses-devel ncurses
//According to the 1999 ISO C standard (C99), size_t is an unsigned integer type of at least 16 bit
//size_t is a type guaranteed to hold any array index
//------------ SOCKETS --------------
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <malloc.h>
/**********************************************************************
* constants
**********************************************************************/
#define SUCCESS 0
#define FAILED 1
#define SOCK_PATH "/tmp/usocket"
#define MAX 200
#define max_maxprocesses 1300
#define max_maxcores 1300
#define top_max_array_valores 20
#define headercode_char_size 11

energy_model param_energy;

/**********************************************************************
* String functions
**********************************************************************/
struct curl_slist *headers = NULL;

/** Function for increase dynamically a string concatenating strings at the end
* It free the memory of the first pointer if not null
* @return s1 <-- s1 + s2 */
char* concat_and_free(char **s1, const char *s2){
	char *result = NULL;
	unsigned int new_lenght= 1;
	if(s2 != NULL){
		new_lenght+=strlen(s2); //+1 for the null-terminator;
	}
	if(*s1 != NULL){
		new_lenght+= strlen(*s1);//current lenght
		if(new_lenght> malloc_usable_size(*s1)){
			result = (char *) malloc(new_lenght);
			if(result==NULL) {
				printf("Failed to allocate memory.\n");
				exit(1);
			}
			strcpy(result, *s1);
			free(*s1);
		}else
			result = *s1;
	}else{
		result = (char *) malloc(new_lenght);
		if(result==NULL) {
			printf("Failed to allocate memory.\n");
			exit(1);
		}
		result[0]='\0';
	}
	*s1 = result;
	if(s2 != NULL )
		strcat(result, s2);
	return result;
}

/* Initialize libcurl; set headers format */
void init_curl(void) {
	if(headers != NULL )
		return;
	// struct curl_slist *headers= NULL;
	curl_global_init(CURL_GLOBAL_ALL);
	headers = curl_slist_append(headers, "Accept: application/json");
	headers = curl_slist_append(headers, "Content-Type: application/x-ndjson");
	headers = curl_slist_append(headers, "charsets: utf-8");
}

// DESCRIPTION: This function releases resources acquired by curl_global_init.
void close_curl(void) {
	curl_global_cleanup( );
}

//this function is the callback for colleting the response
// write_data will replace the function get_stream_data
size_t write_data(void *ptr, size_t size, size_t nitems, struct url_data *data) {
	// 'data' is set with function such CURLOPT_HEADERDATA
	size_t index = data->size;
	size_t n = (size * nitems);// received is nitems * size long in 'ptr' NOT ZERO TERMINATED
	data->size += (size * nitems);
	#ifdef DEBUG
		fprintf(stderr, "data at %p size=%ld nitems=%ld\n", ptr, size, nitems);
	#endif

	/* Initial memory allocation */
	char *temp_str = (char *) malloc(data->size + 1);
	if(temp_str==NULL) {
		fprintf(stderr, "Failed to allocate memory.\n");
		return 0;
	}
	unsigned int i=0;//instead of data->data = (char*) realloc(data->data, data->size + n);
	while((data->data[i]!='\0') &&(i < (unsigned int) index)) {
		temp_str[i]=data->data[i];
		i++;
	}
	temp_str[i]='\0';
	if(data->data!=NULL) free(data->data);
	data->data=NULL;
	data->data=temp_str;
	memcpy((data->data + index), ptr, n);
	data->data[data->size] = '\0';
	if(n>9){
		char tempinit[20];
		memcpy(tempinit, ptr, 9);
		tempinit[9] = '\0';
		int rc = strcmp(tempinit, "HTTP/1.1 ");//[0..8]
		if(rc == 0){
			if(data->headercode==NULL)
				data->headercode = (char *) malloc(headercode_char_size);
			//we wish to cut the first 9 characters which must be: "HTTP/1.1 ",
			// then take those numeric characters after that
			i=0;
			while (data->data[i+9]>='0' && data->data[i+9]<='9' && i<headercode_char_size){
				data->headercode[i]=data->data[i+9];
				i++;
			}
			data->headercode[i]='\0';
		}
	}
	return size * nitems;
}

/** Prepare for using libcurl with message */
CURL *prepare_publish(const char *URL,const char *message, FILE *send_fp, const char *operation ) {
// struct curl_httppost *formpost = NULL;
// struct curl_httppost *lastptr = NULL;
// 		if(send_fp!= NULL){
// 		 curl_global_init(CURL_GLOBAL_ALL);

// curl_mime *form = NULL;
// curl_mimepart *field = NULL;
//
// form = curl_mime_init(curl);
//
// /* Fill in the file upload field */
// field = curl_mime_addpart(form);
// curl_mime_name(field, "UploadJSON");
// curl_mime_filedata(field, "/home/jmontana/phantom_mf/Monitoring_client/my-json-parser/exec_stats.json");
//
// // 		/* Fill in the filename field */
// // 		field = curl_mime_addpart(form);
// // 		curl_mime_name(field, "filename");
// // 		curl_mime_data(field, "postit2.c", CURL_ZERO_TERMINATED);
//
// // 		/* Fill in the submit field too, even if this is rarely needed */
// // 		field = curl_mime_addpart(form);
// // 		curl_mime_name(field, "submit");
// // 		curl_mime_data(field, "send", CURL_ZERO_TERMINATED);
// curl_easy_setopt(curl, CURLOPT_MIMEPOST, form);
// ******************************************
// curl_formadd(&formpost,
// 			&lastptr,
// 			CURLFORM_COPYNAME, "UploadJSON",
// 			CURLFORM_FILE, "/home/jmontana/phantom_mf/Monitoring_client/my-json-parser/exec_stats.json",
// 			CURLFORM_END);
// other files should be next
// curl_formadd(&formpost,
// 			&lastptr,
// 			CURLFORM_COPYNAME, "UploadJSON",
// 			CURLFORM_COPYCONTENTS, "exec_stats.json",
// 			CURLFORM_END);
// ******************************************
// 		/* to get the file size */
// 		printf("set the file for the curl !!\n");
// 		if(fstat(fileno(send_fp), &file_info) != 0)
// 			return NULL; /* can't continue */
//
// 		/* tell it to "upload" to the URL */
// 		curl_easy_setopt(curl, CURLOPT_UPLOAD, 1L);
//
// 		/* set where to read from */
// 		curl_easy_setopt(curl, CURLOPT_READDATA, send_fp);//opened for read operation
//
// 		/* and give the size of the upload (optional) */
// 		curl_easy_setopt(curl, CURLOPT_INFILESIZE_LARGE, (curl_off_t)file_info.st_size);
// 	}

// 	struct stat file_info;
	init_curl( );//this defined the headers
	CURL *curl = curl_easy_init();
	curl_easy_setopt(curl, CURLOPT_NOSIGNAL, 1);//not using signals to notify timeouts on requests and seems not to work fine with multi-threading
	curl_easy_setopt(curl, CURLOPT_URL, URL);
	curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
	if (message!= NULL){
		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, message);
		curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, (long ) strlen(message));
	}
// 		if(send_fp!= NULL){
// 			curl_easy_setopt(curl, CURLOPT_HTTPPOST, formpost);
// 		}
	curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, operation); /* PUT, POST, ... */

	#ifdef DEBUG
	curl_easy_setopt(curl, CURLOPT_VERBOSE, 1L);
	#endif
	return curl;
}

void free_data_struc(struct url_data *data){
	if(data->data!=NULL) free(data->data);
	if(data->headercode!=NULL) free(data->headercode);
	data->data=NULL;
	data->headercode=NULL;
}

int reserve_data_struc(struct url_data *data){
	data->size = 0;
	data->data = malloc(5192); /* reasonable size initial buffer */
	if(NULL == data->data) {
		data->data=NULL;
		data->headercode=NULL;
		return FAILED;
	}
	data->data[0] = '\0';
	data->headercode = malloc(headercode_char_size); /* reasonable size initial buffer */
	if(NULL == data->headercode) {
		free_data_struc(data);
		return FAILED;
	}
	data->headercode[0]= '\0';
	return SUCCESS;
}

int query_message_json_data(const char *URL, const char *message,const char *filenamepath, struct url_data *response, const char *operation) {
	struct curl_slist *headers = NULL;
	struct url_data data;
	if(reserve_data_struc(&data)==FAILED){
		return FAILED;
	}
	struct url_data rescode;
	if(reserve_data_struc(&rescode)==FAILED){
		free_data_struc(&data);
		return FAILED;
	}
	response->data=NULL;
// 	if(check_URL(URL)!=SUCCESS) {
// 		free(data.data); data.data=NULL;
// 		free(data.headercode); data.headercode=NULL;
// 		free(rescode.data); rescode.data=NULL;
// 		free(rescode.headercode); rescode.headercode=NULL;
// 		return FAILED;
// 	}
	if(filenamepath!= NULL){
		// 	curl_slist_free_all(headers);/* free the list again */
		// 	curl_global_init(CURL_GLOBAL_ALL);kkj
	// 	headers = curl_slist_append(headers, string("X-Auth-Token: " + token).c_str());
		headers = curl_slist_append(headers, "Expect: 100-continue");
		headers = curl_slist_append(headers, "Content-type: multipart/form-data");
		headers = curl_slist_append(headers, "charsets: utf-8");
// 	}else{
		init_curl( );//this defined the headers
	}
	CURL *curl = NULL;
	struct curl_httppost *formpost = NULL;
	struct curl_httppost *lastptr = NULL;
	if(filenamepath!= NULL){
		curl = curl_easy_init();
		curl_easy_setopt(curl, CURLOPT_NOSIGNAL, 1);//not using signals to notify timeouts on requests and seems not to work fine with multi-threading
		curl_easy_setopt(curl, CURLOPT_URL, URL);
		curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
		if (message!= NULL){
			curl_easy_setopt(curl, CURLOPT_POSTFIELDS, message);
			curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, (long ) strlen(message));
		}
		curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, operation); /* PUT, POST, ... */
// 		curl_easy_setopt(curl, CURLOPT_VERBOSE, 1L);
		if(filenamepath!= NULL){
			curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
			curl_global_init(CURL_GLOBAL_ALL);
			curl_formadd(&formpost,
				&lastptr,
				CURLFORM_COPYNAME, "UploadJSON",
				CURLFORM_FILE, filenamepath,
	// 			CURLFORM_CONTENTTYPE, "application/octet-stream",
				CURLFORM_END);
		}
		if(filenamepath!= NULL){
	// 		curl_easy_setopt(curl, CURLOPT_UPLOAD, 1L);kaka
			curl_easy_setopt(curl, CURLOPT_HTTPPOST, formpost);
		}
	}else
		curl = prepare_publish(URL, message, NULL, operation);
	if(curl == NULL) {
		free(data.data); data.data=NULL;
		free(data.headercode); data.headercode=NULL;
		free(rescode.data); rescode.data=NULL;
		free(rescode.headercode); rescode.headercode=NULL;
// 		if(headers!=NULL) free(headers);
		curl_slist_free_all(headers);
		return FAILED;
	}

	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data); // the functions get_stream_data seems was not correct.
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, &data);
	curl_easy_setopt(curl, CURLOPT_HEADERFUNCTION, write_data);//header_callback);
	curl_easy_setopt(curl, CURLOPT_HEADERDATA, &rescode); // set userdata in callback function
	CURLcode response_code = curl_easy_perform(curl);
// 	printf("\n URL is %s\n", URL);
// 	printf("\n message is %s\n", message);
// 	printf("\n RESCODE is %s\n", rescode.headercode);
// 	printf("\n data is %s\n", data.data);
	free(rescode.data); rescode.data=NULL;
	//curl_slist_free_all(headers);/* free the list again */
	if(filenamepath!=NULL)
		curl_formfree(formpost);
	curl_easy_cleanup(curl);
// 	curl_global_cleanup();kkj
	if(response_code != CURLE_OK) {
		const char *error_msg = curl_easy_strerror(response_code);
		printf("ERROR query_message_json %s", error_msg);
		free(data.data); data.data=NULL;
		free(data.headercode); data.headercode=NULL;
		free(rescode.data); rescode.data=NULL;
		free(rescode.headercode); rescode.headercode=NULL;
// 		if(headers!=NULL) free(headers);
		curl_slist_free_all(headers);
		return FAILED;
	}
	if (strcmp(rescode.headercode, "401") == 0) {
		printf("ERROR unauthorized request, %s", data.data);
// 		printf("token is %s", token);
		free(data.data); data.data=NULL;
		free(data.headercode); data.headercode=NULL;
		free(rescode.data); rescode.data=NULL;
		free(rescode.headercode); rescode.headercode=NULL;
// 		if(headers!=NULL) free(headers);
		curl_slist_free_all(headers);
		return FAILED;
	}

	if(data.data[0]=='\0') {
		printf("ERROR!! : query with %s failed.\n", URL);
		free(data.data); data.data=NULL;
		free(data.headercode); data.headercode=NULL;
		free(rescode.data); rescode.data=NULL;
		free(rescode.headercode); rescode.headercode=NULL;
// 		if(headers!=NULL) free(headers);
		curl_slist_free_all(headers);
		return FAILED;
	}
	if(response->data !=NULL) free(response->data);
	if(response->headercode !=NULL) free(response->headercode);
	response->data=data.data;
	response->headercode =rescode.headercode;

	free(data.headercode); data.headercode=NULL;
	free(rescode.data); rescode.data=NULL;
// 	if(headers!=NULL) free(headers);
	curl_slist_free_all(headers);
	if(response->data == NULL){
		return FAILED;
	}
	return SUCCESS;
}

//size_t write_data(void *ptr, size_t size, size_t nmemb, struct url_data *data) {
//	size_t index = data->size;
//	size_t n = (size * nmemb);
//	char* tmp;
//	data->size += (size * nmemb);
//	#ifdef DEBUG
//	fprintf(stderr, "data at %p size=%ld nmemb=%ld\n", ptr, size, nmemb);
//	#endif
//	tmp = realloc(data->data, data->size + 1);/* +1 for '\0' */
//	if(tmp) {
//		data->data = tmp;
//	} else {
//		if(data->data)
//			free(data->data);
//		fprintf(stderr, "Failed to allocate memory.\n");
//		return 0;
//	}
//	memcpy((data->data + index), ptr, n);
//	data->data[data->size] = '\0';
//	return size * nmemb;
//}

int longitud(const char cadena1[]){
	int i=0;
	while (cadena1[i]!='\0')
		i++;
	return(i);
}

int int_digits(const int value){
	unsigned int i=0;
	int n;
	n=value;
	while(n>0){
		n=n/10;
		i++;
	}
	return i;
}

void to_lowercase(char *output_str, const char *input_str){
	int i=0;
	while(input_str[i]!='\0'){
		if((input_str[i]>64)&&(input_str[i]<91)) {
			output_str[i]=input_str[i]+ 97 - 65;
		}else{
			output_str[i]=input_str[i];
		}
		i++;
	}
	output_str[i]='\0';
}

int int_pow(const int number, const unsigned int power){
	unsigned int result =1;
	for(int i=0;i<power;i++)
		result *= number;
	return result;
}

void int_to_string(char *output, const int value, const int digits){
	unsigned int i;
	unsigned int contador=digits-1;
	for(i=0;i<digits;i++){
		output[i]=48+((int)((value)/int_pow(10, contador) )%10);
		contador--;
	}
	output[digits]='\0';
}

void add_int_to_str(char *str_2_add, const int position, const int number, const int digits){
	char minumero[20];
	int_to_string(minumero, number, digits);
	for(int i=0;i<=digits;i++) str_2_add[position+i]=minumero[i];//included the end of string char '\0'
}

unsigned int getline_str(char *input, char *output, unsigned const int start){
	unsigned int j=0;
	while((input[j+start]!='\n')&&(input[j+start]!='\0')){
		output[j]=input[j+start];
		j++;
	}
	output[j]='\0';
	return (start+j+1);
}

unsigned int find_str(int start, char source[], const char cad1[]){
	int longsource=longitud(source);
	int longcad=longitud(cad1);
	if (longsource<longcad)
		return(longsource+1);
	int i=start;
	int iguales;
	do{
		iguales=true;
		for (int j=0;j<longcad;j++)
			if (source[i+j]!=cad1[j])
				iguales=false;
		i++;
	} while ((iguales==false) && (i<=(longsource-longcad)));
	if (iguales==false)
		return(longsource+1);
	i--;// Habiamos sumado uno de mas
	return (i);
}

int get_first_int(const int start,int *end, char *loadstr, int *dato){
	int pos=start;
	int found=false;
	*dato=0;
	while( ((loadstr[pos]<48)||(loadstr[pos]>57)) && (loadstr[pos]!='\n') && (loadstr[pos]!='\0') ){
		pos++;
	}
	if((loadstr[pos]>=48)&&(loadstr[pos]<=57)){
		found=true;
		while((loadstr[pos]>=48)&&(loadstr[pos]<=57)){
			*dato=*dato*10+loadstr[pos]-48;
			pos++;
		}
	}
	if ((loadstr[pos]=='\n') || (loadstr[pos]=='\0')) pos++;
	*end=pos;
	return found;
}



int remove_str(int start ,char source[], const char cadenaBuscar[]){
	int longsource=longitud(source);
	int longcad=longitud(cadenaBuscar);
	if (longsource>=longcad){
		int i=find_str(start,source, cadenaBuscar);
		if (i+longcad<=longsource) { // Encontramos la cadena 1 y empieza en i1
			for (int j=i;j<=longsource;j++)
				source[j]=source[j+longcad];
			return(true);
		//}else{
		//	printf(" i %i longcad %i long source %i\n",i,longcad,longsource);
		}
	}
	return(false);
}

int find_int_from_label(char *loadstr, const char *label, int *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<longitud(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atoi(result);
		return true;
	}
	return false;
}


int find_float_from_label(char *loadstr, const char *label, float *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<longitud(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') || (loadstr[i]=='.') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atof(result);
		return true;
	}
	return false;
}


int find_lint_from_label(char *loadstr, const char *label, long int *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<longitud(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atol(result);
		return true;
	}
	return false;
}

int find_llint_from_label(char *loadstr, const char *label, long long int *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<longitud(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atoll(result);
		return true;
	}
	return false;
}

unsigned int process_str(char *input, char *output, unsigned const int start, const unsigned int max_output_size){
	unsigned int j=0;
	while((input[j+start]!='\n')&&(input[j+start]!='\0')&&(input[j+start]!=' ')&&(j+1<max_output_size) ){
		output[j]=input[j+start];
		j++;
	}
	output[j]='\0';
	return (start+j);
}

struct string {
	char *ptr;
	size_t len;
};



typedef struct {
	int *array_valores;
	int total_pids;
	char *pids;
	char **array_params;
} process_runnning_params;




size_t writefunc(void *ptr, size_t size, size_t nmemb, struct string *s) {
	size_t new_len = s->len + size*nmemb;
	s->ptr = realloc(s->ptr, new_len+1);
	if (s->ptr == NULL) {
		fprintf(stderr, "realloc() failed\n");
		exit(EXIT_FAILURE);
	}
	memcpy(s->ptr+s->len, ptr, size*nmemb);
	s->ptr[new_len] = '\0';
	s->len = new_len;
	return size*nmemb;
}

// char *handle_url(char* url, char *to_post) {
// 	CURL *curl;
// 	//char *response;
// 	//char *effective_url;
// 	//char *response_string;
// 	//char *header_string;
// 	//long response_code;
// 	//double elapsed;
// 	//struct url_data data;
// 	//data.size = 4096;
// 	//data.data = (char *) malloc(data.size * sizeof(char));/* reasonable size initial buffer */
// 	//if(NULL == data.data) {
// 	//	fprintf(stderr, "Failed to allocate memory.\n");
// 	//	return NULL;
// 	//}
// 	//data.data[0] = '\0';
// 	struct string response_string;
// 	init_string(&response_string);
//
// 	CURLcode res;
// 	curl = curl_easy_init();
// 	if (curl) {
// 		curl_easy_setopt(curl, CURLOPT_VERBOSE, 0);
// 		curl_easy_setopt(curl, CURLOPT_URL, url);
// 		curl_easy_setopt(curl, CURLOPT_POST, 1);
// 		curl_easy_setopt(curl,CURLOPT_POSTFIELDS,to_post);
// 		/* if we don't provide POSTFIELDSIZE, libcurl will strlen() by itself */
// 		curl_easy_setopt(curl,CURLOPT_POSTFIELDSIZE,(long)strlen(to_post));
// 		//feedback funtion to collect the response
// 		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writefunc);
// 		curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response_string);
// 		/* Perform the request, res will get the return code */
// 		res = curl_easy_perform(curl);
// 		/* Check for errors */
// 		if(res != CURLE_OK)
// 			fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
// 		/* always cleanup */
// 		curl_easy_cleanup(curl);
// 		//curl_easy_setopt(curl, CURLOPT_URL, url);
// 		//curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, writeFunction);
// 		//curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response_string);
// 		//curl_easy_setopt(curl, CURLOPT_HEADERDATA, &header_string);
// 		//curl_easy_getinfo(curl, CURLINFO_RESPONSE_CODE, &response_code);
// 		//curl_easy_getinfo(curl, CURLINFO_TOTAL_TIME, &elapsed);
// 		//curl_easy_getinfo(curl, CURLINFO_EFFECTIVE_URL, &effective_url);
// 	}
// 	return response_string.ptr;
// }



// void process_url(char* url, char *to_post) {
// 	char* data;
// 	data = handle_url(url, to_post);
// 	if(data) {
// 		//printf("%s\n", data);
// 		free(data);
// 		data=NULL;
// 	}
// }




int kbhit(void) {
	struct termios oldt, newt;
	int ch, oldf;
	tcgetattr(STDIN_FILENO, &oldt);
	newt = oldt;
	newt.c_lflag &= ~(ICANON | ECHO);
	tcsetattr(STDIN_FILENO, TCSANOW, &newt);
	oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
	fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);
	ch = getchar();
	tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
	fcntl(STDIN_FILENO, F_SETFL, oldf);
	if(ch !=EOF) {
		ungetc(ch, stdin);
		return 1;
	}
	return 0;
}


//it seems that /proc/stat updates every 10ms, duringh which period a task could run on different core, then there is a chance for an ocasional error on the statistics
//This function fix the statistics to reasonable values, such ocasinally modifing the core ids of some tasks
//ejemplo: 2 cores y tareas 60 45 40 25 25,
//asignamos la tarea 60 al [0], y la 45 al [1]
//si asignamos el 40 al [0] se pueden asignar las 2 utlimas tareas al [1]
//si asignamos el 40 al [1] entonces no se pueden asignar las ultimas tareas.
//algortimo: repartir de mayor a menor caraga entre el core que tienen asignado si esta completamente sin asignar tarea
//           en otro caso buscamos el core con mas carga donde pueda alojarse
void fix_Desynchronized_data(unsigned int maxcores, struct task_data_t *my_task_data){
	int found=false;
	int i,j,c=0;
	unsigned int lista[my_task_data->maxprocesses];
	float sorted_list_pcpu[my_task_data->maxprocesses];
	int total_sorted=0;
	for(i=0;i<my_task_data->maxcores;i++)
		my_task_data->cores[i].total_load_core =0.0;
	for(j=0;j<my_task_data->totaltid;j++)
		my_task_data->cores[my_task_data->subtask[j].currentcore].total_load_core = my_task_data->cores[my_task_data->subtask[j].currentcore].total_load_core + my_task_data->subtask[j].pcpu;
	//existe el problema que algun core por encima del 100?
	c=0;
	while((c<maxcores)&&(found==false)){
		if(my_task_data->cores[c].total_load_core>100.0)
			found=true;
		c++;
	}
	//if(found==false) return;//nothing to do
	for(c=0;c<maxcores;c++)
		my_task_data->cores[c].total_load_core=0.0;
	//now we sort the list of tasks from higher to the lowest load
	for(i=0;i<my_task_data->totaltid;i++){
		//anadimos su carga a la lista
		j=0;
		while((j< total_sorted)&&(my_task_data->subtask[i].pcpu < sorted_list_pcpu[j]))
			j++;
		//vamos en la posicion j, si no es el ultimo desplazamos los demas
		if(total_sorted>0){
			int k=total_sorted;
			while((k>=j)&&(k>0)){
				lista[k]=lista[k-1];
				sorted_list_pcpu[k]= sorted_list_pcpu[k-1];
				k--;
			}
		}
		sorted_list_pcpu[j]=my_task_data->subtask[i].pcpu;
		lista[j]=i;
		total_sorted++;
	}
	for(j=0;j<my_task_data->totaltid;j++){
		int wishedcore=my_task_data->subtask[lista[j]].currentcore;
		if(my_task_data->cores[wishedcore].total_load_core==0.0){
			my_task_data->cores[wishedcore].total_load_core= my_task_data->subtask[lista[j]].pcpu;
		}else{
			found=0;
			for(c=0;c<maxcores;c++){
				if(my_task_data->cores[c].total_load_core>my_task_data->cores[found].total_load_core){
					if( my_task_data->cores[c].total_load_core+sorted_list_pcpu[j]< 100.0)
						found=c;
				}else {
					if( my_task_data->cores[found].total_load_core+sorted_list_pcpu[j]> 100.0)
						found=c;
				}
			}
			//the load of the task j has to be for core[c]
			my_task_data->subtask[lista[j]].currentcore=found;
			my_task_data->cores[found].total_load_core+= my_task_data->subtask[lista[j]].pcpu;
			if(my_task_data->cores[found].total_load_core>100.0) my_task_data->cores[found].total_load_core=100.0;
		}
	}
	//for(j=0;j<my_task_data->totaltid;j++)
	//	printf(" core %i load %f ", my_task_data->subtask[j].currentcore, my_task_data->subtask[j].pcpu);
	// printf("\n");
	//printf("sorted list\n");
	//for(j=0;j<my_task_data->totaltid;j++)
	//	printf("j%i core %i load %f ",lista[j], my_task_data->subtask[lista[j]].currentcore, my_task_data->subtask[lista[j]].pcpu);
	// printf("\n");
	//for(c=0;c<maxcores;c++)
	//	printf("TOTAL CORE %f ",my_task_data->cores[c].total_load_core);
	// printf("\n");
}



void add_str_to_curl(char *source, char *destination, size_t *total_malloc, size_t *used_length){
	size_t additional_data;
	additional_data = longitud(source);
	if (*used_length + additional_data + 1>= *total_malloc) {
		*total_malloc *= 2;
		destination = realloc(destination, *total_malloc);
	}
	memmove(destination + *used_length, source, additional_data+1);// destination source numbytes
	*used_length =*used_length + additional_data;
}

//returns the current time in us
//requires: #include <sys/time.h>
long long int mycurrenttime (void) {
	//struct timeval t0;
	//gettimeofday(&t0, NULL);//https://blog.habets.se/2010/09/gettimeofday-should-never-be-used-to-measure-time.html
	//long long int timeus = (long int) (t0.tv_sec *1000000LL + t0.tv_usec );
	struct timespec ts_start;
	clock_gettime(CLOCK_MONOTONIC, &ts_start);
	long long int timeus = (long int) (ts_start.tv_sec*1000000000LL + ts_start.tv_nsec );
	return timeus;
}

unsigned int build_curl_request( process_runnning_params *mydata, char *curlcommand, char *to_post, size_t *curl_total_malloc, unsigned int maxcores, struct task_data_t *my_task_data, struct system_data mysystem, char *lower_case_searchprocess){
	unsigned int i;
	unsigned int active_processes=0;
	struct timeval tv;
	char str_2_add[256];
	char str_time[128];
	struct tm *timeinfo;
	//time_t rawtime;time (&rawtime);timeinfo = localtime (&rawtime);lo da en segundos?
	gettimeofday(&tv, NULL);timeinfo = localtime(&tv.tv_sec);//lo da en us
	int milliseconds = (int) (tv.tv_usec / 1000);
	//printf ("local_timestamp %4d-%2d-%2dT%2d:%2d:%2d.%3d\"}'",,timeinfo->tm_hour, timeinfo->tm_min, timeinfo->tm_sec, milliseconds);

	sprintf(str_time, "\"local_timestamp\":\"%4d-", timeinfo->tm_year + 1900);
	int longitud_time= longitud(str_time);

	add_int_to_str(str_time, longitud_time, timeinfo->tm_mon+1, 2);
		str_time[longitud_time+2]='-';
		str_time[longitud_time+3]='\0';
		longitud_time+=3;
	add_int_to_str(str_time, longitud_time, timeinfo->tm_mday, 2);
		str_time[longitud_time+2]='T';
		str_time[longitud_time+3]='\0';
		longitud_time+=3;
	add_int_to_str(str_time, longitud_time, timeinfo->tm_hour-2, 2);
		str_time[longitud_time+2]=':';
		str_time[longitud_time+3]='\0';
		longitud_time+=3;
	add_int_to_str(str_time, longitud_time, timeinfo->tm_min, 2);
		str_time[longitud_time+2]=':';
		str_time[longitud_time+3]='\0';
		longitud_time+=3;
	add_int_to_str(str_time, longitud_time, timeinfo->tm_sec, 2);
		str_time[longitud_time+2]='.';
		str_time[longitud_time+3]='\0';
		longitud_time+=3;
	add_int_to_str(str_time, longitud_time, milliseconds, 3);
		str_time[longitud_time+3]='\"';
		str_time[longitud_time+4]=',';
		str_time[longitud_time+5]='\0';//'\'';
		str_time[longitud_time+6]='\0';
		longitud_time+=6;

//char str_2_add[128]="curl -s -XPOST http://localhost:9400/stats_";
// 	char str_2_add[128]="http://localhost:9400/stats_";
// 	strcat(str_2_add, lower_case_searchprocess);
// 	strcat(str_2_add,"/experiment");//expected to use 48 bytes including end of line '\0'
// 	sprintf(curlcommand, "%s",str_2_add);

// 	strcpy(str_2_add,"{");//strcpy(str_2_add,"-d '{\n");
// 	sprintf(to_post, "{%s",str_2_add);

// 	strcpy(str_2_add,"");//strcpy(str_2_add,"-d '{\n");
// 	sprintf(to_post, "{\"index\":{\"_index\":\"rm\"}}\n");
// 	add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);

	to_post[0]='\0';
	size_t curl_length = 0;// longitud(to_post);
	//for(i=0;i<maxcores;i++) {
	//	sprintf(str_2_add, "    \"CORE%i\": %5.1f,\n", i, cores[i].total_load_core);
	//	add_str_to_curl(str_2_add, curlcommand, curl_total_malloc, &curl_length);
	//}
	long long int actual_time=mycurrenttime();

	for(i=0;i<my_task_data->totaltid;i++){
		if(my_task_data->subtask[i].totaltime==0){
			active_processes++;
			sprintf(str_2_add, "{\"index\":{\"_index\":\"rm\"}}\n");
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, "{ %s",str_time);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"pspid\": %5i,",my_task_data->subtask[i].pspid);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"pstid\": %5i,",my_task_data->subtask[i].pstid);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);


			unsigned int indice=1;
			while((indice<=mydata->total_pids)&&(mydata->array_valores[indice]!=my_task_data->subtask[i].pspid)){
				indice++;
			}
			if(indice<= mydata->total_pids){
				sprintf(str_2_add, " \"params\": \"%s\",",mydata->array_params[indice]);
					add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			}else{
				sprintf(str_2_add, " \"params\": \"\"," );
					add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			}

			sprintf(str_2_add, " \"pcpu\": %5.1f,",my_task_data->subtask[i].pcpu);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);

	long int freq_min=400000;
	long int freq_max=2800000;
	float MAX_CPU_POWER=55.5/4.0;//[0] <--- per core
	float MIN_CPU_POWER=11.0/4.0;//[1] <--- per core
// 	int L2CACHE_LINE_SIZE=128;//[4]
// 	int L2CACHE_MISS_LATENCY=59.80;//[3]
// 	float MEMORY_POWER=2.016;//[2]
// 	float case_fan= 1;
// 	float motherboard_power = 40;
// 	float sata_drive=15.0;
// 	float hd_power = 3.5;
// 	param_energy.E_DISK_R_PER_MB=0.0556;//[5]
// 	param_energy.E_DISK_W_PER_MB=0.0438;//[6]
	// Read/Write  6.00 Watts
	// Idle        5.50 Watts
	// Standby     0.80 Watts
	// Sleep       0.80 Watts

			float power_range =  MAX_CPU_POWER - MIN_CPU_POWER;//for freq_min and freq_max
			long int freqs=2000000;//my_task_data->cores[i].core_freq; //in KHz
			float total_joules_core=my_task_data->subtask[i].pcpu *( MIN_CPU_POWER + power_range * (freqs- freq_min)/( freq_max- freq_min))/100.0; // in milliJoule

// 			printf(" constant %5.8f \n",MIN_CPU_POWER + power_range * (freqs- freq_min)/( freq_max- freq_min) );
// 			fflush(stdout);
// 			exit(1);

			float total_watts_core = 0.0;

// 		my_task_data->cores[i].total_joules_core=
// 			my_task_data->cores[i].total_load_core*(param_energy.MIN_CPU_POWER + power_range * (freqs-param_energy.freq_min)/(param_energy.freq_max-param_energy.freq_min))/100.0; // in milliJoule
		if(my_task_data->subtask[i].time_of_last_measured!=0){
			long long int total_time = (actual_time - my_task_data->subtask[i].time_of_last_measured);
			my_task_data->subtask[i].time_between_measures=total_time;
			total_watts_core =  total_joules_core*(1.0e-9)*total_time;

			printf(" constant %.4f \n",(1.0e-9)*total_time );
			fflush(stdout);
// 			exit(1);
		}
		my_task_data->subtask[i].time_of_last_measured=actual_time;

			sprintf(str_2_add, " \"total_watts\": %1.3f,",total_watts_core);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);


			sprintf(str_2_add, " \"pmem\": %5.1f,",my_task_data->subtask[i].pmem);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"rchar\": %7lli,",my_task_data->subtask[i].rchar);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"wchar\": %7lli,",my_task_data->subtask[i].wchar);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"syscr\": %7lli,",my_task_data->subtask[i].syscr);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"rd\": %7lli,",my_task_data->subtask[i].read_bytes);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"wr\": %7lli,",my_task_data->subtask[i].write_bytes);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
			sprintf(str_2_add, " \"cancel\": %lli}\n",my_task_data->subtask[i].cancelled_write_bytes);
				add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
		}
	}

// 	printf(" mydata->total_pids %i \n",mydata->total_pids);
// 	printf("total %i\n",mydata->total_pids);
// 	for(i=1;i<=mydata->total_pids;i++){
// 		printf(" contador %i pid %i param %s\n",i, mydata->array_valores[i], mydata->array_params[i]);
// 	}
// 	printf(" totaltid %i \n",my_task_data->totaltid);
// 	for(int kk=0; kk< my_task_data->totaltid;kk++){
// 		printf("   %i: ",kk );
// 		printf(" %i  \n ", my_task_data->subtask[kk].pspid );
// 	}
// 	fflush(stdout);
// 	exit(1);




// 	if(active_processes>0){
// 		sprintf(str_2_add, "   \"total_task_load\": %5.1f,\n", my_task_data->total_load_cpu / maxcores);
// 			add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
// 	}else{
// 		curlcommand[0]='\0';
// 		to_post[0]='\0';
// 		return active_processes;
// 	}


	sprintf(str_2_add, "{\"index\":{\"_index\":\"rm\"}}\n");
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, "{ %s",str_time);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, " \"system_mem_total\": %i,", mysystem.MemTotal);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, " \"system_mem_free\": %i,", mysystem.MemFree);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, " \"system_mem_buffers\": %i,", mysystem.Buffers);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, " \"system_mem_cached\": %i,", mysystem.Cached);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, " \"system_mem_used\": %i,", mysystem.usedmemory);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	sprintf(str_2_add, " \"system_cpu_load\": %5.2f}", mysystem.cpu_system_load);
		add_str_to_curl(str_2_add, to_post, curl_total_malloc, &curl_length);
	return active_processes;
}

size_t execute_command(const char *command, char *comout, size_t *comalloc){
	// Setup our pipe for reading and execute our command.
	FILE *fd;
	size_t comlen = 0;
	fd = popen(command,"r");//if (!fd) == if(fp==NULL) This if statement implicitly checks "is not 0", so we reverse that to mean "is 0".
	if (fd!=NULL){
		char buffer[5256];
		size_t chread;
		/* Use fread so binary data is dealt with correctly */
		while ((chread = fread(buffer, 1, sizeof(buffer), fd)) != 0) {
			if (comlen + chread +1>= *comalloc) {
				*comalloc = *comalloc + *comalloc;
				comout = (char *) realloc(comout, *comalloc * sizeof(char));
			}
			memmove(comout + comlen, buffer, chread);// destination source numbytes
			comlen += chread;
		}
		pclose(fd);
	}
	comout[comlen]='\0';
	/* We can now work with the output as we please. Just print out to confirm output is as expected */
	//fwrite(comout, 1, comlen, stdout);
	return comlen;
}


int recv_msg_from_server(int socketfd, char data[]) {
	struct msghdr msg;
	struct iovec iov;
	int s;
	memset(&msg, 0, sizeof(msg));
	memset(&iov, 0, sizeof(iov));
	msg.msg_name = NULL;
	msg.msg_namelen = 0;
	iov.iov_base = data;
	iov.iov_len = MAX;
	msg.msg_iov = &iov;
	msg.msg_iovlen = 1;
	msg.msg_control = NULL;
	msg.msg_controllen = 0;
	msg.msg_flags = 0;
	s = recvmsg(socketfd, &msg, 0);
	if(s < 0){
		perror("recvmsg");
		return 0;
	}
	return s;
}

// int mysocket(char *receivedmsg){
// 	int s, len, slen;
// 	struct sockaddr_un remote;
// 	if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
// 		perror("socket");
// 		exit(1);
// 	}
// 	memset(&remote, 0, sizeof(remote));
// 	remote.sun_family = AF_UNIX;
// 	strcpy(remote.sun_path, SOCK_PATH);
// 	len = strlen(remote.sun_path) + sizeof(remote.sun_family);
// 	if (connect(s, (struct sockaddr *)&remote, len) != -1) {
// 		//printf("Connected.\n");
// 		slen = recv_msg_from_server(s, receivedmsg);
// 		if (slen < 0) perror("recvmsg");
// 		//printf(" msg received > %s\n", receivedmsg);
// 		close(s);
// 		return true;
// 	}
// 	close(s);
// 	return false;
// }

// Example on myltithread pidof
// 24243 24243   1  0.0  0.0 51176
// 24243 24254   1  2.0  0.0 51176
// 24243 24255   3  2.0  0.0 51176
// 24243 24256   2  1.1  0.0 51176
// 24243 24257   3  0.0  0.0 51176
// 24243 24259   0 94.9  0.0 51176


// 	printf("total %i\n", contador);
// 	for(i=1;i<=contador;i++){
// 		printf(" contador %i pid %i param %s\n",i,mydata->array_valores[i], mydata->array_params[i]);
// 	}
// 	fflush(stdout);
// 	exit(1);

unsigned int procesa_pid_load(process_runnning_params *mydata, char *comout, size_t *comalloc, unsigned int argmaxcores, struct task_data_t *my_task_data,energy_model param_energy) {
	float power_range = param_energy.MAX_CPU_POWER - param_energy.MIN_CPU_POWER;//for freq_min and freq_max
	unsigned int i,contador,maxcores=argmaxcores;
	const int size_loadstr=40;
	char loadstr[size_loadstr];
	#define max_command 1200
	char command[max_command];//needed 55 + size of pid
	for(i=0;i<my_task_data->maxprocesses;i++)
		my_task_data->subtask[i].updated=false;
	my_task_data->totalpmem=0;
	my_task_data->total_load_cpu=0.0;
	long long int actual_time=mycurrenttime();
	int j, found;
	int pspid, pstid, currentcore;
	float pcpu, pmem;
	if(mydata->pids[0]!='\0') {
		i=0;
		while(mydata->pids[i]!='\0')//it is a string with the list of pids
			i++;
		if(55+i>max_command){
			printf(" error not space in the string\n");
			exit (1);
		}
		// Execute a process listing
		sprintf(command, "ps --no-headers -p %s -L -o pid,tid,psr,pcpu,pmem,size", mydata->pids);//stime,time
		size_t comlen = execute_command( command, comout, comalloc);
		//update all the loads to 0 of all tasks registerd in my_task_data
		//first need to find if the pspid and pstid were already registered in my_task_data, its position will be stored in "index"
		//if not find register, then create a new entry and define the current time as start time
		if(comlen!=0){
			i=0;
			contador=0;
			while((comout[i]!='\0')&&(i<comlen)&&(i<*comalloc)){
				while (comout[i]==' ')
					i++;
				if((comout[i]!='\0')&&(i<comlen)&&(i<*comalloc)){
				if(comout[i]!=' '){
					contador++;
					i=process_str(comout, loadstr, i, size_loadstr);//loads into the string loadstr the next entry in the input line
					if(contador==1){
						pspid=atoi(loadstr);
					}else if(contador==2) {
						pstid=atoi(loadstr);
					}else if(contador==3) {
						currentcore=atoi(loadstr);
						if((maxcores< currentcore+1)&&( currentcore+1<my_task_data->maxprocesses))
							maxcores= currentcore+1;
					}else if(contador==4){
						pcpu=atof(loadstr);
						if( pcpu>100.0)
							pcpu=100.0;//evaluated cases shows few glitches when start running a program.
					}else if(contador==5){
						pmem=atof(loadstr);
						my_task_data->totalpmem+= pmem;
					}
				}}
				if ((comout[i]!='\0')&&(i<comlen)&&(i<*comalloc)){
				if(comout[i]=='\n'){
					j=0;
					found=false;
					while((j<my_task_data->totaltid)&&(found==false)){
						if((my_task_data->subtask[j].pspid==pspid)&&(my_task_data->subtask[j].pstid==pstid)){
							found=true;
						}else{
							j++;
						}
					}
					if((found==false)&&(my_task_data->totaltid<my_task_data->maxprocesses+1)){
// 						if(pcpu>0.0){//if(pspid==pstid){//we wish to measure even on 0% load
							j=my_task_data->totaltid;
							my_task_data->totaltid=my_task_data->totaltid+1;
							my_task_data->subtask[j].starttime=actual_time;
							if(j==0)
								my_task_data->first_start=actual_time;
							found=true;
							my_task_data->subtask[j].time_of_last_measured=0;
							my_task_data->subtask[j].time_between_measures=0;
							my_task_data->subtask[i].finishtime=0;
// 						}
					}
					if(found==true){
						my_task_data->subtask[j].updated=true;
						my_task_data->subtask[j].pspid=pspid;
						my_task_data->subtask[j].pstid=pstid;

						my_task_data->subtask[j].currentcore=currentcore;
						my_task_data->subtask[j].totaltime=0;
						my_task_data->subtask[j].pcpu=pcpu;
						my_task_data->subtask[j].pmem=pmem;
					}
					contador=0;
					i++;
				}}
			}
		}
	}

	//now we clean the list removing the subtasks not found in the last ps.
	//We update the finishing time
	int count_active_tasks=0;
	int finishing_tasks=0;
	for(i=0;i<my_task_data->totaltid;i++){
		if(my_task_data->subtask[i].updated==true){
			count_active_tasks++;
		}else if(my_task_data->subtask[i].totaltime==0){
			finishing_tasks++;
			my_task_data->subtask[i].finishtime=actual_time;
			my_task_data->subtask[i].totaltime=my_task_data->subtask[i].finishtime- my_task_data->subtask[i].starttime;
			my_task_data->subtask[i].pcpu=0.0;
			my_task_data->subtask[i].pmem=0.0;
		}
	}

	if((count_active_tasks==0)&&(finishing_tasks>0))
		my_task_data->last_end=actual_time;
	if(my_task_data->totaltid>my_task_data->maxtotaltid)
		my_task_data->maxtotaltid=my_task_data->totaltid;
	fix_Desynchronized_data( maxcores, my_task_data);//updates currentcore and total_load_core

	for(i=0;i<maxcores;i++) {
		my_task_data->total_load_cpu+=my_task_data->cores[i].total_load_core;
		long int freqs=my_task_data->cores[i].core_freq;
		my_task_data->cores[i].total_joules_core=
			my_task_data->cores[i].total_load_core*(param_energy.MIN_CPU_POWER + power_range * (freqs-param_energy.freq_min)/(param_energy.freq_max-param_energy.freq_min))/100.0; // in milliJoule
		if(my_task_data->cores[i].time_of_last_measured!=0){
			long long int total_time = (actual_time - my_task_data->cores[i].time_of_last_measured);
			my_task_data->cores[i].time_between_measures=total_time;
			my_task_data->cores[i].total_watts_core+= my_task_data->cores[i].total_joules_core*(1.0e-9)*total_time;
		}
		my_task_data->cores[i].time_of_last_measured=actual_time;
	}
	return maxcores;
}


float procesa_system_load(char *comout, size_t *comalloc, int array_valores_last[] ) {
	float cpu_usage=0.0;
	const char command[]= "if [ -e /proc/stat ];then cat /proc/stat;fi;";//expected to update every 10ms
	execute_command( command, comout, comalloc);
	if(comout[0]!='\0'){
		char loadstr[250];
		int array_valores[top_max_array_valores];
		int endpos=0;
		int dato=0;
		int contador;
		for(contador=0;contador<top_max_array_valores;contador++) array_valores[contador]=0;
		int i=0;
		int end_string=getline_str(comout, loadstr, i);// i<end_string ->> (comout[i]!='\n')
		contador=1;
		while((i<end_string)&&(contador<top_max_array_valores)){// Get all number columns, we skip the first (which is the "cpu" string), depending on the kernel we can get more numbers
			get_first_int(i,&endpos,loadstr, &dato);
			i=endpos;
			array_valores[contador]=dato;
			array_valores[0] +=dato;//it is cpu_sum
			contador++;
		}
		// Get the delta between two reads
		int cpu_delta=array_valores[0] - array_valores_last[0];
		// Get the idle time Delta
		int cpu_idle=array_valores[4] - array_valores_last[4];
		// Calc time spent working
		int cpu_used=cpu_delta - cpu_idle;
		// Calc percentage
		cpu_usage=100.0 * cpu_used / cpu_delta;
		// Keep this as last for our next read
		for(contador=0;contador<top_max_array_valores;contador++)
			array_valores_last[contador]= array_valores[contador];
	}
	return cpu_usage;
}

// cat /proc/cpuinfo | grep "MHz"
//example
// cpu MHz		: 400.040
// cpu MHz		: 400.027
// cpu MHz		: 400.020
// cpu MHz		: 400.008
void procesa_cpuinfo( char *comout, size_t *comalloc, unsigned int argmaxcores, struct task_data_t *my_task_data ) {
	const char command[]= "if [ -e /proc/cpuinfo ];then cat /proc/cpuinfo | grep \"MHz\";fi;";//expected to update every 10ms
	unsigned int i,contador,maxcores=argmaxcores;
	const int size_loadstr=250;
	char loadstr[size_loadstr];
	float my_temp_float;
// 	long long int actual_time=mycurrenttime();
	size_t comlen = execute_command( command, comout, comalloc);
	//update all the loads to 0 of all tasks registerd in my_task_data
	//first need to find if the pspid and pstid were already registered in my_task_data, its position will be stored in "index"
	//if not find register, then create a new entry and define the current time as start time
	if(comlen!=0){
		i=0;
		contador=0;
		while((comout[i]!='\0')&&(i<comlen)){
			if(contador>= maxcores){
				printf(" counter of freqs exceds maxcores\n");
				exit(1);
			}
			while (comout[i]==' ')
				i++;
			int end_string=getline_str(comout, loadstr, i);// i<end_string ->> (comout[i]!='\n')
			i=end_string;
			find_float_from_label( loadstr, "cpu MHz		:", &my_temp_float);
			my_task_data->cores[contador].core_freq=(long int)(my_temp_float*1000);//in KHz
			contador++;//count of cores
		}
	}
}

int procesa_disk_stats(char *comout, size_t *comalloc, struct disk_data *newdata, struct disk_data *olddata, int *valid_disk_data) {
	const int max_devices=20;
	const int max_contador=20;
	static const char command[] = "if [ -e /proc/diskstats ];then cat /proc/diskstats;fi;";
	size_t comlen= execute_command(command,comout, comalloc);
	int i=0, j,contador=0,totaldevices=0;
	const int size_loadstr=250;
	char loadstr[size_loadstr];
	long long int current_sample[max_devices][max_contador];

	while((comout[i]!='\0')&&(i<comlen)&&(totaldevices<max_devices)){
		if((comout[i]!=comout[i+1])&&(comout[i]==' ')){//todos los campos empizan por el caracter espacio
			if(contador==2){//label name of the device
				j=0;
				while((comout[i]==' ')&&(comout[i]!='\0'))
					i++;
				while((comout[i]!=' ')&&(comout[i]!='\0')){
					newdata[totaldevices].labelstr[j]=comout[i];
					i++;j++;
				}
				newdata[totaldevices].labelstr[j]='\0';
				if(i>0) i--;//queremos dejar el espacio despues de la cadena-label para que se detecte el principio del siguiente campo
			}else if(contador<max_contador){
				i=process_str(comout, loadstr, i, size_loadstr);
				current_sample[totaldevices][contador]=atoll(loadstr);
			}
			contador++;
		}
		if(comout[i]=='\n'){
			contador=0;
			totaldevices++;
		}
		i++;
	}
	for(int device=0;device<totaldevices;device++){
		if( newdata[device].labelstr[0]!='l'){
			olddata[device].rd_sectors=newdata[device].rd_sectors;
			olddata[device].wr_sectors=newdata[device].wr_sectors;
			olddata[device].rd_ios=newdata[device].rd_ios;
			olddata[device].wr_ios=newdata[device].wr_ios;

			newdata[device].rd_sectors=current_sample[device][5 ];
			newdata[device].wr_sectors=current_sample[device][9 ];
			newdata[device].rd_ios    =current_sample[device][3 ];
			newdata[device].wr_ios    =current_sample[device][7 ];
			if(*valid_disk_data==0){
				olddata[device].rd_sectors=newdata[device].rd_sectors;
				olddata[device].wr_sectors=newdata[device].wr_sectors;
				olddata[device].rd_ios=newdata[device].rd_ios;
				olddata[device].wr_ios=newdata[device].wr_ios;
			}
		}
	}
	if(*valid_disk_data==0)
		*valid_disk_data=1;
	return totaldevices;
}


long int get_itv( char *comout, size_t *comalloc ) {
	long int itv=0;
	const char command[]= "if [ -e /proc/uptime ];then cat /proc/uptime;fi;";//expected to update every 10ms
	execute_command( command, comout, comalloc);
	if(comout[0]!='\0'){
		char loadstr[250];
		int end_string=getline_str(comout, loadstr, 0);// i<end_string ->> (comout[i]!='\n')
		int i=0;
		int encontrado=false;
		while((i<end_string) &&(comout[i]!='\0')){
			if(comout[i]=='.') encontrado=true;
			if(encontrado==true) comout[i]=comout[i+1];
			i++;
		}
		itv=atoll(comout);
	}
	return itv;
}


void procesa_system_mem(char *comout, size_t *comalloc, struct system_data *mysystem ) {
	const char command[]= "if [ -e /proc/meminfo ];then cat /proc/meminfo;fi;";
	execute_command(command, comout, comalloc);
	if(comout[0]!='\0'){
		int i=0;
		char loadstr[250];
		int SReclaimable=0;
		int SUnreclaim=0;
		while(comout[i]!='\0'){
			i=getline_str(comout, loadstr, i);
			find_int_from_label( loadstr, "MemTotal:", &mysystem->MemTotal);
			find_int_from_label( loadstr, "MemFree:", &mysystem->MemFree);
			find_int_from_label( loadstr, "Buffers:", &mysystem->Buffers);
			unsigned int pos= find_str(0,loadstr,"SwapCached");
			if(pos>longitud(loadstr)) //if it not found SwapCached
				find_int_from_label( loadstr, "Cached:", &mysystem->Cached);
			find_int_from_label( loadstr, "SReclaimable:", &SReclaimable);
			find_int_from_label( loadstr, "SUnreclaim:", &SUnreclaim);
		}
		mysystem->usedmemory= mysystem->MemTotal - mysystem->MemFree - mysystem->Buffers - mysystem->Cached - SReclaimable - SUnreclaim;
	}
}


unsigned int numcores(char *comout, size_t *comalloc) {
	const char command[]= "nproc;";
	execute_command(command, comout, comalloc);
	return atoi(comout);;
}

int longitud_hastalinea(const int ini, const char cadena1[]){
	int i=ini;
	while ((cadena1[i]!='\n')&&(cadena1[i]!='\0'))
		i++;
	return(i-ini);
}

//buscacadenalinea busca cad1 en LINEA[ini,'\n' o '\0']
int buscacadenalinea (const int ini,char *LINEA,const char *cad1){
	int iguales,j;
	int i=ini;
	int long_linea=ini;
	while((LINEA[long_linea]!='\n')&&(LINEA[long_linea]!='\0')){
		long_linea++;
	}
	long_linea=long_linea-ini;
	if (long_linea<longitud(cad1))
		return(ini+long_linea);
	do {
		iguales=true;
		for (j=0;j<longitud(cad1);j++) {
			if (LINEA[i+j]!=cad1[j])
				iguales=false;
		}
		i++;
	}
	while ((iguales==false) && (i<=ini+long_linea-longitud(cad1)));
	if (iguales==false)
		return(ini+long_linea+1);
	i--;// Habiamos sumado uno de mas
	return (i);
}

process_runnning_params *hpc_ips(char *comout, size_t *comalloc, char *appname ) {
	char command[120];
// 	sprintf(command, "pidof %s;",appname);
// 	ps aux | grep app-id | grep -v grep | awk '{print $2}'
// 	sprintf(command, "ps aux | grep %s | grep -v grep | awk '{print $2}';",appname);
	sprintf(command, "ps aux | grep %s | grep -v grep;",appname);
	//$2 is the pid
	// $n is the app-id and the next is the label we are looking for
	process_runnning_params *mydata= (process_runnning_params *)malloc( sizeof(process_runnning_params ));
	execute_command(command,comout, comalloc);
	char string_to_find[]="app-id";
	const int max_contador = 20;

	mydata->array_params= (char **)malloc(max_contador * sizeof(char *));
	for(int kj=0;kj< max_contador;kj++){
		mydata->array_params[kj]= (char *)malloc(128 * sizeof(char ));
	}


	mydata->array_valores= (int *)malloc(max_contador * sizeof(int));
	if(!mydata->array_valores) return NULL;
	mydata->pids= (char *)malloc(max_contador*6 * sizeof(char));
	if(!mydata->pids) return NULL;
	int dato=0;
	int contador=0;
	int i=0;
	if(comout[0]!='\0'){
		while((comout[i]!='\0')&&(contador+1<max_contador)){// Get all number columns, we skip the first (which is the "cpu" string), depending on the kernel we can get more numbers
			if(comout[i]=='\n')   i++;
// 			int found=false;
			dato=0;
			//we go to the pos after the first field, are separated by spaces, the 2nd is the pid
			while(  (comout[i]!='\n') && (comout[i]!='\0') && (comout[i]!=' ') ){
				i++;
			}
			//we skip all the spaces until the second field starts
			while(  (comout[i]!='\n') && (comout[i]!='\0') && (comout[i]==' ') ){
				i++;
			}
			if((comout[i]>=48)&&(comout[i]<=57)){
				while((comout[i]>=48)&&(comout[i]<=57)){
					dato=dato*10+comout[i]-48;
					i++;
				}
			}
			mydata->array_params[contador+1][0]='\0';
			//next we look for the string app-id
			if(comout[i]!='\0'){
			int i1=buscacadenalinea(i, comout, string_to_find);
				int long_hasta=i;
				while(  (comout[long_hasta]!='\n') && (comout[long_hasta]!='\0')   ){
					long_hasta++;
				}
				if(i1<long_hasta){
					//encontramos la cadena app-id !!!
					//found=true;
					//la cadena app-id comiena en i1, asi que podemos buscar la cadena parametro a partir de i1+6
					i=i1+6;
					while(  (comout[i]!='\n') && (comout[i]!='\0') && (comout[i]==' ') ){
						i++;
					}
					int j=0;
					while((comout[i]!='\n') && (comout[i]!='\0') && (comout[i]!=' ') ){
						mydata->array_params[contador+1][j]=comout[i];
						j++;i++;
					}
					mydata->array_params[contador+1][j]='\0';
					mydata->array_valores[contador+1]=dato;
					contador++;
// 					printf(" pid is %i param is %s\n", dato, mydata->array_params[contador]);
				}

			}
			while ((comout[i]!='\n') && (comout[i]!='\0')) i++;
		}
	}
	mydata->array_valores[0]=contador;
	mydata->total_pids= contador;
// 	printf("total %i\n", contador);
// 	for(i=1;i<=contador;i++){
// 		printf(" contador %i pid %i param %s\n",i,mydata->array_valores[i], mydata->array_params[i]);
// 	}
// 	fflush(stdout);
// 	exit(1);

	int pos=0;
	for(i =1;i<=mydata->array_valores[0];i++) {
		int total_digits=int_digits(mydata->array_valores[i]);
		int_to_string(mydata->pids+pos, mydata->array_valores[i], total_digits );
		pos+=total_digits+1;
		if(i<mydata->array_valores[0]){ mydata->pids[pos-1]=',';mydata->pids[pos]='\0';}
	}
// 	fprintf(stderr,"%s", mydata->pids);
// 	if(mydata->array_valores!=NULL) free(mydata->array_valores);
	mydata->pids[pos]='\0';
	return mydata;
}

char *hpc_ipspidof(char *comout, size_t *comalloc, char *appname ) {
	char command[120];
	sprintf(command, "pidof %s;",appname);
	execute_command(command,comout, comalloc);
	char loadstr[250];
	const int max_contador = 20;
	int *array_valores= (int *)malloc(max_contador * sizeof(int));
	if(!array_valores) return NULL;
	char *string_valores= (char *)malloc(max_contador*6 * sizeof(char));
	if(!string_valores) return NULL;
	int endpos=0;
	int dato=0;
	int contador=0;
	int i=0;
	if(comout[i]!='\0'){
		int end_string=getline_str(comout, loadstr, i);// i<end_string ->> (comout[i]!='\n')
		while((i<end_string)&&(contador+1<max_contador)){// Get all number columns, we skip the first (which is the "cpu" string), depending on the kernel we can get more numbers
			int found=get_first_int(i, &endpos, loadstr, &dato);
			i=endpos;
			if(found==true){
				contador++;
				array_valores[contador]=dato;
			}
		}
	}
	array_valores[0]=contador;
	int pos=0;
	for(i =1;i<=array_valores[0];i++) {
		int total_digits=int_digits(array_valores[i]);
		int_to_string(string_valores+pos, array_valores[i], total_digits );
		pos+=total_digits+1;
		if(i<array_valores[0]){ string_valores[pos-1]=',';string_valores[pos]='\0';}
	}
	//fprintf(stderr,"%s", string_valores);
	if(array_valores!=NULL) free(array_valores);
	string_valores[pos]='\0';
	return string_valores;
}


#define NET_STAT_FILE "/proc/%d/net/dev"

/** @brief Gets current network stats (send and receive bytes)
* collected metrics on nets_info->rcv_bytes and nets_info->send_bytes
@return SUCCESS or otherwise FAILURE*/
// int procesa_network_stat_read(int pid, struct task_data_t *my_task_data) {
int procesa_network_stat_read(char *comout, size_t *comalloc, struct task_data_t *my_task_data) {
	FILE *fp;
	unsigned int temp;
	unsigned long long temp_rcv_bytes, temp_send_bytes;
	int subtask=0;
	for(subtask=0;subtask< my_task_data->totaltid;subtask++){
		if(my_task_data->subtask[subtask].updated==true){
			if(my_task_data->subtask[subtask].pstid==my_task_data->subtask[subtask].pspid){
// 				int pstid=my_task_data->subtask[subtask].pstid;
				int pspid=my_task_data->subtask[subtask].pspid;
				if(pspid!=0){
				/* values reset to zeros */
				my_task_data->subtask[subtask].rcv_bytes = 0;
				my_task_data->subtask[subtask].send_bytes = 0;
				char pid_net_file[128], line[1024];
				sprintf(pid_net_file, NET_STAT_FILE, pspid);
				if ((fp = fopen(pid_net_file, "r")) != NULL) {
// 					printf( "Error: Cannot open %s.\n", pid_net_file);
// 					return false;
				while(fgets(line, 1024, fp) != NULL) {
					char *sub_line_eth = strstr(line, "eth");
					if (sub_line_eth != NULL) {
						sscanf(sub_line_eth + 5, "%llu%u%u%u%u%u%u%u%llu",
							&temp_rcv_bytes, &temp, &temp, &temp, &temp, &temp, &temp, &temp,
							&temp_send_bytes);
						my_task_data->subtask[subtask].rcv_bytes += temp_rcv_bytes;
						my_task_data->subtask[subtask].send_bytes += temp_send_bytes;
					}
					char *sub_line_wlan = strstr(line, "wlan");
					if (sub_line_wlan != NULL) {
						sscanf(sub_line_wlan + 6, "%llu%u%u%u%u%u%u%u%llu",
							&temp_rcv_bytes, &temp, &temp, &temp, &temp, &temp, &temp, &temp,
							&temp_send_bytes);
						my_task_data->subtask[subtask].rcv_bytes += temp_rcv_bytes;
						my_task_data->subtask[subtask].send_bytes += temp_send_bytes;
					}
					char *sub_line_lo= strstr(line, "lo");
					if (sub_line_lo != NULL) {
						sscanf(sub_line_lo + 6, "%llu%u%u%u%u%u%u%u%llu",
							&temp_rcv_bytes, &temp, &temp, &temp, &temp, &temp, &temp, &temp,
							&temp_send_bytes);
						my_task_data->subtask[subtask].rcv_bytes += temp_rcv_bytes;
						my_task_data->subtask[subtask].send_bytes += temp_send_bytes;
					}
				}
				fclose(fp);
				}
				}
			}
		}//end if
	}
	return true;
}


void procesa_task_io(char *comout, size_t *comalloc, struct task_data_t *my_task_data ) {
	char command[120];
	int subtask=0 ;
	char loadstr[250];
	for(subtask=0;subtask< my_task_data->totaltid;subtask++){
		if(my_task_data->subtask[subtask].updated==true){
			if(my_task_data->subtask[subtask].pstid==my_task_data->subtask[subtask].pspid){
				int i=0;
				sprintf(command, "if [ -e /proc/%i/io ];then cat /proc/%i/io;fi;",my_task_data->subtask[subtask].pstid,my_task_data->subtask[subtask].pstid);
				execute_command(command,comout, comalloc);
				if(comout[0]!='\0'){
					while(comout[i]!='\0'){//we need to consume line by line
						i=getline_str(comout, loadstr, i);
						find_llint_from_label( loadstr, "rchar: ", &my_task_data->subtask[subtask].rchar);
						find_llint_from_label( loadstr, "wchar: ", &my_task_data->subtask[subtask].wchar);
						find_llint_from_label( loadstr, "syscr: ", &my_task_data->subtask[subtask].syscr);
						find_llint_from_label( loadstr, "syscw: ", &my_task_data->subtask[subtask].syscw);
						find_llint_from_label( loadstr, "read_bytes: ", &my_task_data->subtask[subtask].read_bytes); //really did cause to be fetched from the storage layer
						find_llint_from_label( loadstr, "write_bytes: ", &my_task_data->subtask[subtask].write_bytes); //really did cause to be fetched from the storage layer
						find_llint_from_label( loadstr, "cancelled_write_bytes: ", &my_task_data->subtask[subtask].cancelled_write_bytes);
					} //end while
				}
		}}//end if
	}//end for i
}



int main(int argc, char *argv[]) {
	char address[256]="localhost";
	int port=9200;
	for (unsigned int i=1;i<argc;i++){//i=0 es el name del binary
		if(argv[i][0]=='-'){
			if(strcmp(argv[i],"-h")==0){
				printf(" Usage: stats-with-db [OPTION]... \n");
				printf(" Monitoring client integrated for ElasticSearch server\n");
				printf(" Author: J.M. Montañana Aliaga, 2020\n\n");
				printf(" Arguments:\n");
				printf("    -h, --help              Shows this help\n");
				printf("    -s, --server ADDRESS    Defines the address of the ElasticSearch server, its default value is localhost\n");
				printf("    -p, --port    VALUE     Defines the port number of the ElasticSearch server, its default value is 9400\n\n\n");
				fflush(stdout);
				exit(0);
			}else if((strcmp(argv[i],"-p")==0)||(strcmp(argv[i],"--port")==0)){
				if(argc>i){
					printf("Port number is '%s'\n",argv[i+1]);
					port=atoi(argv[i+1]);
				}else{
					printf("Error missing paramter value\n");exit(1);
				}
			}else if((strcmp(argv[i],"-s")==0)||(strcmp(argv[i],"--server")==0)){
				if(argc>i){
					printf("Server address is '%s'\n",argv[i+1]);
					strcpy(address, argv[i+1]);
				}else{
					printf("Error missing paramter value\n");exit(1);
				}
			}
		}
	}
	char server[256]="";//localhost:9200";
	sprintf(server, "%s:%i", address, port);
	param_energy.freq_min=400000;
	param_energy.freq_max=2800000;

	param_energy.MAX_CPU_POWER=55.5/4.0;//[0] <--- per core
	param_energy.MIN_CPU_POWER=11.0/4.0;//[1] <--- per core
	param_energy.L2CACHE_LINE_SIZE=128;//[4]
	param_energy.L2CACHE_MISS_LATENCY=59.80;//[3]
	param_energy.MEMORY_POWER=2.016;//[2]
	param_energy.case_fan= 1;
	param_energy.motherboard_power = 40;

	param_energy.sata_drive=15.0;

	param_energy.hd_power = 3.5;
// 	param_energy.E_DISK_R_PER_MB=0.0556;//[5]
// 	param_energy.E_DISK_W_PER_MB=0.0438;//[6]
	// Read/Write  6.00 Watts
	// Idle        5.50 Watts
	// Standby     0.80 Watts
	// Sleep       0.80 Watts

// values from https://www.tomshardware.co.uk/desktop-hdd.15-st4000dm000-4tb,review-32729-6.html
// 	WD RED WD30EFRX 3TB 5400 rpm 5.4W
// 	Seagate Desktop HDD 15  4TB 5900 rpm 5.9W
// 	Hitachi Deskstar 5K4000 4TB 5400 rpm 6.0 W
// 	Hitachi Deskstar 5K3000 3TB 5400 rpm 6.4 W
// 	WD Caviar Green WD30ERZRX 3TB 5400 rpm 7.0W
// 	Seagate Barracuda 3TB 7200 rpm 7.9 W
// 	Hitachi Deskstar 7K3000 3TB 7200 rom 8.6W
// 	Hitachi Deskstar 7K4000 4TB 7200 rpm 8.7W
// 	WD Black WD4001FAEX 4TB 7200 rpm 9.3 W
// 	Seagate Barracuda XT 3TB 7200 rpm 9.5W

	param_energy.E_NET_SND_PER_MB=0.14256387;
	param_energy.E_NET_RCV_PER_MB=0.24133936;

	/* String to store entire command contents in */
	size_t comalloc = 255*1024;
	int i;
	char *comout = (char *) malloc(comalloc * sizeof(char));
	cls();
	struct system_data mysystem;
	mysystem.MemTotal=0;
	mysystem.MemFree=0;
	mysystem.Buffers=0;
	mysystem.Cached=0;
	mysystem.usedmemory=0;
	mysystem.cpu_system_load=0;

	struct task_data_t my_task_data_a;
	my_task_data_a.maxprocesses =max_maxprocesses;
	my_task_data_a.maxcores=max_maxcores;
	my_task_data_a.subtask = (struct sub_task_data *) malloc( my_task_data_a.maxprocesses * sizeof(struct sub_task_data));
	my_task_data_a.cores = (struct cores_data *) malloc( my_task_data_a.maxcores * sizeof(struct cores_data));
	my_task_data_a.totaltid=0;
	my_task_data_a.maxtotaltid=1;
	my_task_data_a.first_start=0;
	my_task_data_a.last_end=0;
	my_task_data_a.total_load_cpu=0;
	for(i=0;i<my_task_data_a.maxprocesses;i++){
		my_task_data_a.subtask[i].totaltime=0;
		my_task_data_a.subtask[i].rchar=0;
		my_task_data_a.subtask[i].wchar=0;
		my_task_data_a.subtask[i].syscr=0;
		my_task_data_a.subtask[i].syscw=0;
		my_task_data_a.subtask[i].read_bytes=0;
		my_task_data_a.subtask[i].write_bytes=0;
		my_task_data_a.subtask[i].cancelled_write_bytes=0;
		my_task_data_a.subtask[i].send_bytes=0;
		my_task_data_a.subtask[i].rcv_bytes=0;
	}

	for(i=0;i<my_task_data_a.maxcores;i++){
		my_task_data_a.cores[i].total_joules_core=0;
		my_task_data_a.cores[i].time_of_last_measured=0;
		my_task_data_a.cores[i].total_watts_core=0;
	}
	size_t curl_malloc = 8256;
	char *curlcommand= (char *) malloc(curl_malloc * sizeof(char));
	char *to_post= (char *) malloc(curl_malloc * sizeof(char));
	int array_valores[top_max_array_valores];
	for(i=0;i<top_max_array_valores;i++) array_valores[i]=0;
	struct disk_data newdata[top_max_array_valores];
	struct disk_data olddata[top_max_array_valores];
	int totaldevices=6;
	for(int device=0;device<totaldevices;device++){
		olddata[device].rd_sectors=0;
		olddata[device].wr_sectors=0;
		olddata[device].rd_ios=0;
		olddata[device].wr_ios=0;
	}
// 	char input_parameters[MAX];
	char searchprocess[MAX];//max is 200 chars
	char lower_case_searchprocess[MAX];
	int valid_disk_data=0;
	strcpy(searchprocess,"app-id");//PHANTOM_MPI-Distributed
	to_lowercase(lower_case_searchprocess, searchprocess);
	unsigned int maxcores= numcores(comout, &comalloc);
	unsigned int max_painted=0;//variable for painting in thescreen
	int curr_lines=0,curr_cols=0;

	while (!kbhit()) {
// 		if(mysocket(input_parameters)==true){
// 			//printf(" mensage \"%s\"\n",searchprocess);fflush(stdout);
// 			//exit(1);
// 			if((input_parameters[0]=='-')&&((input_parameters[1]=='c')||(input_parameters[1]=='C')) ){
// 				my_task_data_a.totaltid=0;
// 				my_task_data_a.maxtotaltid=1;
// 				my_task_data_a.first_start=0;
// 				my_task_data_a.last_end=0;
// 				for(i=0;i<my_task_data_a.maxprocesses;i++)
// 					my_task_data_a.subtask[i].totaltime=0;
// 			}else if((input_parameters[0]=='-')&&((input_parameters[1]=='t')||(input_parameters[1]=='T')) ){
// 				i=3;
// 				while(input_parameters[i]!='\0'){
// 					searchprocess[i-3]=input_parameters[i];
// 					i++;
// 				}
// 				searchprocess[i-3]='\0';
// 				to_lowercase(lower_case_searchprocess, searchprocess);
// 			}
// 		}

		process_runnning_params *mydata=hpc_ips( comout, &comalloc, searchprocess);

// 		char *pids=mydata->pids;
		procesa_cpuinfo( comout, &comalloc, maxcores, &my_task_data_a);
		maxcores=	procesa_pid_load(mydata, comout, &comalloc, maxcores, &my_task_data_a, param_energy);
					procesa_task_io( comout, &comalloc, &my_task_data_a);
					procesa_network_stat_read(comout, &comalloc, &my_task_data_a);
					procesa_system_mem(comout, &comalloc, &mysystem);//global of the system
					mysystem.cpu_system_load= procesa_system_load(comout, &comalloc, array_valores);
		totaldevices=procesa_disk_stats( comout, &comalloc, newdata, olddata, &valid_disk_data);
		unsigned int active_processes= build_curl_request(mydata,curlcommand, to_post, &curl_malloc, maxcores, &my_task_data_a, mysystem,lower_case_searchprocess);
//**********************************************************************************************
		max_painted=print_stats(max_painted, active_processes, maxcores, &curr_lines, &curr_cols, searchprocess, &my_task_data_a, &mysystem, curlcommand, to_post, param_energy);
//**********************************************************************************************
		char *filenamepath=NULL;
		char *URL = NULL;
		char operation_post[]="POST";
		struct url_data response;
		response.size=0;
		response.data=NULL;
		response.headercode=NULL;
		URL = NULL;
		URL=concat_and_free(&URL, server);
		URL=concat_and_free(&URL, "/rm/infrastructure/_bulk");
		size_t curl_length =  longitud(to_post);
		add_str_to_curl("\n", to_post, &curl_malloc, &curl_length);
// 		The bulk request must be terminated by a newline [\n] !!!
// 		int result=
		query_message_json_data(URL, to_post, filenamepath, &response, operation_post);
// 		if(result!=FAILED){
// 			printf("code %s\n %s\n",response.headercode, response.data);
// 			fflush(stdout);
// 		}else{
// 			printf("FAILED\n");
// 		}
		const int max_contador = 20;
		for(int kj=0;kj< max_contador;kj++){
			free(mydata->array_params[kj]);
		}
		free(mydata->array_params);
		free(mydata->array_valores);
		free(mydata->pids);
		free(mydata);
		usleep(420000);
	}
	free(curlcommand);
	free(to_post);
	printf(" fin de programa\n");
	free(my_task_data_a.subtask);
	free(my_task_data_a.cores);
	free(comout);
	return 0;
}
