#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <stdbool.h>

#include <termios.h>
#include <unistd.h> //for sleep and usleep
//#include <time.h> //for nano sleep
#include <fcntl.h>
#include <ctype.h>
#include <sys/select.h>

#include "mymath.h"

unsigned int lengthstring(const char input[]){
	unsigned int i=0;
	while(input[i]!='\0') i++;
	return i;
}

void to_lowercase(char *output_str, const char *input_str){
	int i=0;
	while(input_str[i]!='\0'){
		if((input_str[i]>64)&&(input_str[i]<91)) {
			output_str[i]=input_str[i]+ 97 - 65;
		}else{
			output_str[i]=input_str[i];
		}
		i++;
	}
	output_str[i]='\0';
}

int int_digits(const int value){
	unsigned int i=0;
	int n;
	n=value;
	while(n>0){
		n=n/10;
		i++;
	}
	return i;
}

void int_to_string(char *output, const int value, const int digits){
	unsigned int i;
	unsigned int contador=digits-1;
	for(i=0;i<digits;i++){
		output[i]=48+((int)((value)/int_pow(10, contador) )%10);
		contador--;
	}
	output[digits]='\0';
}

/*
* digits: the number of digits in the string:
* number= 5, digits =2 --> 02
* number= 5, digits =3 --> 002
*/
void add_int_to_str(char *str_2_add, const int position, const int number, const int digits){
	char minumero[20];
	int_to_string(minumero, number, digits);
	for(int i=0;i<=digits;i++) str_2_add[position+i]=minumero[i];//included the end of string char '\0'
}

/*
* copy from position "start" of the string "input" into the string "output"
* until find end of string, end of line or a space character ' '
*/
unsigned int process_str(char *input, char *output, unsigned const int start, const unsigned int max_output_size){
	unsigned int j=0;
	while((input[j+start]!='\n')&&(input[j+start]!='\0')&&(input[j+start]!=' ')&&(j+1<max_output_size) ){
		output[j]=input[j+start];
		j++;
	}
	output[j]='\0';
	return (start+j);
}

/*
* copy from position "start" of the string "input" into the string "output"
* until find end of string or end of line
*/
unsigned int getline_str(char *input, char *output, unsigned const int start){
	unsigned int j=0;
	while((input[j+start]!='\n')&&(input[j+start]!='\0')){
		output[j]=input[j+start];
		j++;
	}
	output[j]='\0';
	return (start+j+1);
}

//search for the string cad1 in the string source, starting from position "start"
//if found: return ths position where starts the cad1 in the string source
//if not found: returns a not valid value, which is the lenght of source +1
unsigned int find_str(int start, char source[], const char cad1[]){
	int longsource=lengthstring(source);
	int longcad=lengthstring(cad1);
	if (longsource<longcad)
		return(longsource+1);
	int i=start;
	int iguales;
	do{
		iguales=true;
		for (int j=0;j<longcad;j++)
			if (source[i+j]!=cad1[j])
				iguales=false;
		i++;
	} while ((iguales==false) && (i<=(longsource-longcad)));
	if (iguales==false)
		return(longsource+1);
	i--;// Habiamos sumado uno de mas
	return (i);
}

//removes the string "cadenaBuscar" from the string "source"
//returns true if the string "cadenaBuscar" was found and removed
int remove_str(int start ,char source[], const char cadenaBuscar[]){
	int longsource=lengthstring(source);
	int longcad=lengthstring(cadenaBuscar);
	if (longsource>=longcad){
		int i=find_str(start,source, cadenaBuscar);
		if (i+longcad<=longsource) { // Encontramos la cadena 1 y empieza en i1
			for (int j=i;j<=longsource;j++)
				source[j]=source[j+longcad];
			return(true);
		//}else{
		//	printf(" i %i longcad %i long source %i\n",i,longcad,longsource);
		}
	}
	return(false);
}

//it searches for the first integer from the position "start" in a text string
//if found number:
//		the funtion returns TRUE if found number
// 		returns in "end" the ending position of the number found in the string.
//		returns dato with the value of the number found
// if not found number:
//		the funtion returns FALSE if found number
// 		returns in "end" the position of the end of the line, or end of the string if not found any end of line
//		returns dato with zero
int get_first_int(const int start,int *end, char *loadstr, int *dato){
	int pos=start;
	int found=false;
	*dato=0;
	while( ((loadstr[pos]<48)||(loadstr[pos]>57)) && (loadstr[pos]!='\n') && (loadstr[pos]!='\0') ){
		pos++;
	}
	if((loadstr[pos]>=48)&&(loadstr[pos]<=57)){
		found=true;
		while((loadstr[pos]>=48)&&(loadstr[pos]<=57)){
			*dato=*dato*10+loadstr[pos]-48;
			pos++;
		}
	}
	if ((loadstr[pos]=='\n') || (loadstr[pos]=='\0')) pos++;
	*end=pos;
	return found;
}

//if can remove the label from the beggining of string
//then returns the int remaining in the string
int find_int_from_label(char *loadstr, const char *label, int *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<lengthstring(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atoi(result);
		return true;
	}
	return false;
}

int find_float_from_label(char *loadstr, const char *label, float *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<lengthstring(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') || (loadstr[i]=='.') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atof(result);
		return true;
	}
	return false;
}

int find_lint_from_label(char *loadstr, const char *label, long int *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<lengthstring(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atol(result);
		return true;
	}
	return false;
}

int find_llint_from_label(char *loadstr, const char *label, long long int *to_update){
	char result[200];
	if(remove_str(0,loadstr, label)==true){
		int i=0;
		while( (i<lengthstring(loadstr)) && ( ((loadstr[i]>47)&&(loadstr[i]<58)) || (loadstr[i]==' ') )){
			result[i]=loadstr[i];
			i++;
		}
		result[i]='\0';
		*to_update=atoll(result);
		return true;
	}
	return false;
}

int longitud(const char cadena1[]){
	int i=0;
	while (cadena1[i]!='\0')
		i++;
	return(i);
}


int buscacadena (int ini,char *LINEA,const char *cad1){
	int iguales,j;
	int i=ini;
	if (longitud(LINEA)<longitud(cad1))
		return(longitud(LINEA));
	do {
		iguales=true;
		for (j=0;j<longitud(cad1);j++) {
			if (LINEA[i+j]!=cad1[j])
				iguales=false;
		}
		i++;
	}
	while ((iguales==false) && (i<=(longitud(LINEA)-longitud(cad1))));
	if (iguales==false)
		return(longitud(LINEA)+1);
	i--;// Habiamos sumado uno de mas
	return (i);
}


//returns in the string temp , the text between cad1 y cad2 found in string LINEA starting from position ini
int textoentre(const char cad1[],const char cad2[], int ini, char *LINEA, char temp[]) {
	int i1,i2,j;
	stpcpy (temp, "");
	if (longitud(LINEA)>longitud(cad1)+longitud(cad2)) {
		i1=buscacadena(ini,LINEA, cad1);
		if (i1<=(longitud(LINEA)-longitud(cad1))) { // Encontramos la cadena 1 y empieza en i1
			i1=i1+longitud(cad1);
			if (cad2[0]!='\0') {
				if ((longitud(LINEA)-i1)>longitud(cad2)) {
					i2=buscacadena(i1,LINEA, cad2);//empezamos a partir de la primera cadena
					if (i2<=(longitud(LINEA)-longitud(cad2))) {// Encontramos la cadena 2 y empieza en i2
						for (j=0;j<i2-i1;j++)
							temp[j]=LINEA[i1+j];
						temp[i2-i1]='\0';
						return 1;
					}
				}
			} else {
				i2=longitud(LINEA);
				for (j=0;j<i2-i1;j++)
					temp[j]=LINEA[i1+j];
				temp[i2-i1]='\0';
				return 1;
			}
		}
	}
	return 0;
}

