struct url_data {
	size_t size;
	char* headercode;
	char* data;
};

struct system_data{
	int MemTotal;
	int MemFree;
	int Buffers;
	int Cached;
	int usedmemory;
	float cpu_system_load;
};

struct sub_task_data {
	unsigned int currentcore, pspid, pstid;
	float pmem, pcpu;
	long long int time_between_measures, time_of_last_measured;
	int updated;
	long long int finishtime,totaltime,starttime;
	long long int rchar, wchar, syscr, syscw, read_bytes, write_bytes,cancelled_write_bytes, rcv_bytes, send_bytes;
};

struct cores_data {
	float total_load_core;
	float total_joules_core;
	long long int time_of_last_measured;
	long long int time_between_measures;
	float total_watts_core;
	long int core_freq;
};

typedef struct task_data_t {
// 	unsigned int tids[max_report_tids];
	unsigned long int microsleep;
	int pid;
	int maxprocesses, maxcores;
	unsigned int maxtotaltid;
	unsigned int totaltid;//counts the total of subtasks
	struct sub_task_data *subtask;  //for the subtasks running  WARNING is ** in mf_api
	unsigned int total_user_def; //counts the total of user_def params
	struct sub_task_user_def **task_def;  //for the of user_def params
	struct cores_data *cores;  //for the total of cores running
	float total_load_cpu, totalpmem;
	long long int first_start,last_end;
}task_data;


struct disk_data{
	char labelstr[250];
	long long int rd_sectors;
	long long int wr_sectors;
	long long int rd_ios;
	long long int wr_ios;
};

typedef struct energy_model_t {
	//CPU Energy Model:
	unsigned long long freq_min;//400000 KHz
	unsigned long long freq_max;//2800000 KHz
	float MAX_CPU_POWER;//24.5;//[0]<--- per core
	float MIN_CPU_POWER;//6.0;//[1]  <--- per core
	//MEM Energy Model:
	float L2CACHE_LINE_SIZE;//=128;
	float L2CACHE_MISS_LATENCY;//=59.80;
	float MEMORY_POWER;//=2.016;  W/Gb
// SDRAM = 1.1 GB/s * 3.0 Ws/GB = 3.3W
// DDR   = 2.9 GB/s * 1.5 Ws/GB = 4.4W
// DDR2  = 5.0 GB/s * 0.5 Ws/GB = 2.5W
// 		values are such:
// 		DDR1 RAM (2.5 Volts) 4 to 5.5 W (depending of the clock freq)
// 		DDR2 RAM (1.8 Volts) 3 to 4.5 W
// 		DDR3 RAM (1.5 Volts) 2 to 3 W
	float sata_drive;//=15.0;
// 		values are such:
// 		SATA DVD Drive 15 to 27 W
// 		SATA Blu-ray Drive 25 to 30 W
	float case_fan;// = 1;
// 		values are such:
// 		80 mm Case Fan (2,000 RPM) 0.6 to 1.8 W
// 		80 mm Case Fan (3,000 RPM) 2.4 to 3 W
// 		120 mm Case Fan (1,200 RPM) 0.6 to 2.3 W
// 		120 mm Case Fan (2,000 RPM) 3.6 to 6 W
// 		140 mm Case Fan (1,000 RPM) 0.9 to 1.7 W
// 		140 mm Case Fan (2,000 RPM) 4.2 to 6 W
	float hd_power;// = 8;
// 		values are such:
// 		Solid State Drive SSD 0.6 to 2.8 W
// 		2.5" Hard Disk Drive HDD 0.7 to 3 W
// 		3.5" Hard Disk Drive HDD 6.5 to 9 W
// 	float E_DISK_R_PER_KB;//=0.0556;
// 	float E_DISK_W_PER_KB;//=0.0438;
	float E_NET_SND_PER_MB;//=0.14256387;
	float E_NET_RCV_PER_MB;//=0.24133936;

	float motherboard_power;// = 40;
// 		values are such:
// 		Regular Motherboard 25 to 40 W
// 		High End Motherboard 45 to 80 W
}energy_model;
